/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"

void ending(int * state)
{
    int i, x, y, src;

    mailbox[0] = GPU_ENDING_TILES_RAM;
    mailbox[1] = ENDING_TILESET_SIZE;
    mailbox[2] = 0;
    hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 3, GPU_MAILBOX);

    memset(video_ram, 0, sizeof(video_ram));
    memset(sprite_ram, 0, sizeof(sprite_ram));

    for (i = 0; i < 951; i++) {
        // vsync
        waitpeq(GPU_VSYNC, GPU_VSYNC);
        waitpne(GPU_VSYNC, GPU_VSYNC);

        if (i < 360) {
            x = i/60;

            src = ENDING_TILE_600_72_ID + ((64 / 8) * (48 / 8) * x);
            for (y = 72 / 8; y < (72 + 48) / 8; y++) {
                for (x = 96 / 8; x < (96 + 64) / 8; x++) {
                    video_ram[y][x] = src++;
                }
            }
            hs_tx((64 * 6) / 4, (int32_t)&video_ram[9][0], 0, GPU_VIDEO_RAM + (9 * 64) / 4);
        }
        else if (i == 365) {
            mailbox[0] = GPU_ENDING_TILEMAP;
            hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 4, GPU_MAILBOX);
        }
    }

    mailbox[0] = 0;
    mailbox[1] = 0;
    mailbox[2] = 0;
    hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 5, GPU_MAILBOX);

    *state = 0;
}
