/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <stdint.h>

#include "graphics.h"

int32_t room_02_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   1,  56 << 8, 144 << 8,   0, ROOM_02_SPRITE_96_40_OFS,   0,  56 << 8, 224 << 8,  128,   0,   1 << 8,  13 << 8,   6 << 8,  15 << 8, },
    {   1, 216 << 8, 144 << 8,   1, ROOM_02_SPRITE_96_40_OFS,   0,  56 << 8, 224 << 8,  128,   0,   1 << 8,  13 << 8,   6 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_03_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   1,  32 << 8, 152 << 8,   2, ROOM_03_SPRITE_160_40_OFS,   0,  88 << 8, 128 << 8,  230,   0,   3 << 8,  12 << 8,   4 << 8,  11 << 8, },
    {   1,  64 << 8, 136 << 8,   2, ROOM_03_SPRITE_192_40_OFS,   0, 104 << 8, 144 << 8,  230,   0,   3 << 8,  12 << 8,   4 << 8,  11 << 8, },
    {   1,  80 << 8, 104 << 8,   2, ROOM_03_SPRITE_160_40_OFS,   0,  88 << 8, 128 << 8,  230,   0,   3 << 8,  12 << 8,   4 << 8,  11 << 8, },
    {   1, 192 << 8, 120 << 8,   2, ROOM_03_SPRITE_192_40_OFS,   0, 112 << 8, 144 << 8,  153,   0,   3 << 8,  12 << 8,   4 << 8,  11 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_04_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   3,  40 << 8, 136 << 8,   0, SPRITE_64_64_OFS,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   3,  72 << 8, 136 << 8,   0, SPRITE_64_64_OFS,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   3, 176 << 8, 136 << 8,   1, SPRITE_64_64_OFS,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   3, 208 << 8, 136 << 8,   1, SPRITE_64_64_OFS,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_05_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
};

int32_t room_06_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
    {  17,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   1 << 8,  13 << 8,   0 << 8,  23 << 8, },
};

int32_t room_08_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   2, 144 << 8,  48 << 8,   1, ROOM_08_SPRITE_224_40_OFS,   0,  32 << 8, 160 << 8,  128,   0,   1 << 8,  13 << 8,   2 << 8,  11 << 8, },
    {   2, 168 << 8,  88 << 8,   0, ROOM_08_SPRITE_224_40_OFS,   0,  80 << 8, 224 << 8,  102,   0,   1 << 8,  13 << 8,   2 << 8,  11 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_09_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   1, 104 << 8, 152 << 8,   1, ROOM_09_SPRITE_512_48_OFS,   0,  80 << 8, 152 << 8,   76,   0,   2 << 8,  13 << 8,   4 << 8,   7 << 8, },
    {   1, 160 << 8,  48 << 8,   0, ROOM_09_SPRITE_512_48_OFS,   0, 144 << 8, 184 << 8,   76,   0,   2 << 8,  13 << 8,   4 << 8,   7 << 8, },
    {   5,  48 << 8,  88 << 8,   3, ROOM_09_SPRITE_320_64_OFS,   0,  56 << 8, 128 << 8,  179,   0,   2 << 8,  13 << 8,   0 << 8,  15 << 8, },
    {   5,  72 << 8, 104 << 8,   2, ROOM_09_SPRITE_320_64_OFS,   0,  80 << 8, 136 << 8,  179,   0,   2 << 8,  13 << 8,   0 << 8,  15 << 8, },
    {   5, 152 << 8,  96 << 8,   2, ROOM_09_SPRITE_320_64_OFS,   0,  96 << 8, 136 << 8,  179,   0,   2 << 8,  13 << 8,   0 << 8,  15 << 8, },
    {   5, 176 << 8,  80 << 8,   3, ROOM_09_SPRITE_320_64_OFS,   0,  72 << 8, 128 << 8,  179,   0,   2 << 8,  13 << 8,   0 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_10_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  16, 120 << 8,   8 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,  85 << 8,   0 << 8,  32 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_11_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  16, 104 << 8,  72 << 8,   1, ROOM_11_SPRITE_576_40_OFS,   0,   0 << 8,   0 << 8,   25,   0,   1 << 8,  14 << 8,   0 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_12_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   4,  32 << 8,  64 << 8,   2, ROOM_12_SPRITE_560_24_OFS,   0,  40 << 8, 150 << 8,  230,   0,   1 << 8,  13 << 8,   1 << 8,  13 << 8, },
    {   4,  48 << 8,  16 << 8,   3, ROOM_12_SPRITE_256_40_OFS,   0,   8 << 8,  64 << 8,  102,   0,   1 << 8,  13 << 8,   1 << 8,  13 << 8, },
    {   4, 128 << 8, 120 << 8,   3, ROOM_12_SPRITE_256_40_OFS,   0, 112 << 8, 144 << 8,  102,   0,   1 << 8,  13 << 8,   1 << 8,  13 << 8, },
    {   4, 160 << 8,  64 << 8,   2, ROOM_12_SPRITE_560_24_OFS,   0,   8 << 8, 144 << 8,  230,   0,   1 << 8,  13 << 8,   1 << 8,  13 << 8, },
    {   4, 176 << 8,  72 << 8,   3, ROOM_12_SPRITE_560_24_OFS,   0,   8 << 8, 144 << 8,  230,   0,   1 << 8,  13 << 8,   1 << 8,  13 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_13_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   3, 144 << 8,  88 << 8,   1, ROOM_13_SPRITE_128_64_OFS,   0,  88 << 8, 176 << 8,  128,   0,   1 << 8,  13 << 8,   3 << 8,  15 << 8, },
    {   3, 126 << 8, 136 << 8,   1, ROOM_13_SPRITE_128_64_OFS,   0,  64 << 8, 128 << 8,  128,   0,   1 << 8,  13 << 8,   8 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_14_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   1, 120 << 8, 152 << 8,   1, ROOM_14_SPRITE_512_48_OFS,   0,  48 << 8, 184 << 8,   76,   0,   2 << 8,  13 << 8,  4 << 8,  7 << 8, },
    {  17, 136 << 8,  32 << 8,   0, 0,   0, 152 << 8,  48 << 8,    0,   0,   2 << 8,  13 << 8,  10 << 8,  15 << 8, },
    {  17, 224 << 8,  48 << 8,   0, 0,   0, 152 << 8,  96 << 8,    0,   0,   2 << 8,  13 << 8,   7 << 8,  15 << 8, },
    {  17, 112 << 8, 112 << 8,   0, 0,   0, 152 << 8,  96 << 8,    0,   0,   2 << 8,  13 << 8,   7 << 8,  15 << 8, },
    {   1,  48 << 8,  32 << 8,   2, ROOM_14_SPRITE_160_40_OFS,   0,   8 << 8,  64 << 8,  128,   0,   3 << 8,  12 << 8,   4 << 8,  12 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_15_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   3,  88 << 8,  56 << 8,   1, ROOM_15_SPRITE_0_64_OFS,     0,  80 << 8, 112 << 8,  128,   0,   1 << 8,  13 << 8,   8 << 8,  15 << 8, },
    {   3, 160 << 8, 136 << 8,   0, ROOM_15_SPRITE_0_64_OFS,     0, 128 << 8, 192 << 8,  128,   0,   1 << 8,  13 << 8,   1 << 8,  15 << 8, },
    {  12, 192 << 8,  32 << 8,   0, ROOM_15_SPRITE_640_40_OFS,   0,  32 << 8, 108 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
    {  12, 208 << 8,  32 << 8,   0, ROOM_15_SPRITE_640_40_OFS,   0,  32 << 8, 140 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
    {  12,  88 << 8,  32 << 8,   0, ROOM_15_SPRITE_640_40_OFS,   0,  32 << 8,  76 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
    {  12,  88 << 8,  88 << 8,   0, ROOM_15_SPRITE_640_40_OFS,   0,  88 << 8, 124 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
    {  12,  32 << 8,  88 << 8,   0, ROOM_15_SPRITE_640_40_OFS,   0,  88 << 8, 124 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
};

int32_t room_16_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  13,  60 << 8, 160 << 8,   0, ROOM_16_SPRITE_480_40_OFS,   0,  72 << 8, 176 << 8,    0,   0,   3 << 8,  12 << 8,   1 << 8,  14 << 8, },
    {  13, 160 << 8, 160 << 8,   0, ROOM_16_SPRITE_480_40_OFS,   0,  88 << 8, 176 << 8,    0,   0,   3 << 8,  12 << 8,   1 << 8,  14 << 8, },
    {  13, 116 << 8, 160 << 8,   0, ROOM_16_SPRITE_480_40_OFS,   0,  80 << 8, 176 << 8,    0,   0,   3 << 8,  12 << 8,   1 << 8,  14 << 8, },
    {   1, 148 << 8,  16 << 8,   2, ROOM_16_SPRITE_160_40_OFS,   0,   8 << 8,  64 << 8,  128,   0,   3 << 8,  12 << 8,   4 << 8,  11 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_17_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  15,  16 << 8,  24 << 8,   0, ROOM_17_SPRITE_256_64_OFS,   0,  16 << 8, 225 << 8,    0,   0,   1 << 8,  13 << 8,   7 << 8,  15 << 8, },
    {  15, 224 << 8,  72 << 8,   1, ROOM_17_SPRITE_256_64_OFS,   0,  16 << 8, 225 << 8,    0,   0,   1 << 8,  13 << 8,   7 << 8,  15 << 8, },
    {  15, 120 << 8, 104 << 8,   1, ROOM_17_SPRITE_256_64_OFS,   0,  16 << 8, 225 << 8,    0,   0,   1 << 8,  13 << 8,   7 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_18_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  16,  16 << 8,   8 << 8,   0, ROOM_18_SPRITE_0_88_OFS,   0,  16 << 8, 208 << 8,    0,   0,   0 << 8,  32 << 8,   0 << 8,  27 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_19_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  12,  48 << 8,   8 << 8,   0, ROOM_19_SPRITE_640_40_OFS,   0,   8 << 8,  48 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
    {  13, 142 << 8, 160 << 8,   0, ROOM_19_SPRITE_480_40_OFS,   0,  80 << 8, 176 << 8,    0,   0,   3 << 8,  12 << 8,   1 << 8,  14 << 8, },
    {  13, 192 << 8, 160 << 8,   0, ROOM_19_SPRITE_480_40_OFS,   0,  88 << 8, 176 << 8,    0,   0,   3 << 8,  12 << 8,   1 << 8,  14 << 8, },
    {   1,  88 << 8,  32 << 8,   2, ROOM_19_SPRITE_160_40_OFS,   0,   8 << 8,  72 << 8,  128,   0,   3 << 8,  12 << 8,   4 << 8,  11 << 8, },
    {  12, 128 << 8,   8 << 8,   0, ROOM_19_SPRITE_640_40_OFS,   0,   8 << 8,  64 << 8,    0,   0,   5 << 8,  10 << 8,   0 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_20_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  11, 216 << 8,  24 << 8,   1, ROOM_20_SPRITE_448_40_OFS,   0,   8 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   3, 120 << 8, 136 << 8,   0, ROOM_20_SPRITE_0_64_OFS,   0,  80 << 8, 144 << 8,  153,   0,   1 << 8,  13 << 8,   0 << 8,  15 << 8, },
    {   6, 120 << 8,  88 << 8,   1, ROOM_20_SPRITE_464_24_OFS,   0,  32 << 8, 208 << 8,  179,   0,   1 << 8,   3 << 8,   2 << 8,  14 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_21_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  15, 192 << 8, 120 << 8,   1, ROOM_21_SPRITE_256_64_OFS,   0,  16 << 8, 233 << 8,    0,   0,   3 << 8,  12 << 8,   7 << 8,  15 << 8, },
    {   3,  56 << 8,  40 << 8,   0, ROOM_21_SPRITE_192_64_OFS,   0,  16 << 8,  96 << 8,  128,   0,   1 << 8,  13 << 8,   2 << 8,  15 << 8, },
    {   3,  24 << 8, 136 << 8,   0, ROOM_21_SPRITE_192_64_OFS,   0,  16 << 8, 128 << 8,  128,   0,   1 << 8,  13 << 8,   2 << 8,  15 << 8, },
    {   3, 120 << 8, 136 << 8,   0, ROOM_21_SPRITE_192_64_OFS,   0,  16 << 8, 128 << 8,  128,   0,   1 << 8,  13 << 8,   2 << 8,  15 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_22_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  11, 224 << 8, 104 << 8,   1, ROOM_22_SPRITE_448_40_OFS,   0,   8 << 8, 240 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   3,  72 << 8,   8 << 8,   1, ROOM_22_SPRITE_352_64_OFS,   0,  16 << 8, 104 << 8,  128,   0,   1 << 8,  13 << 8,   0 << 8,  12 << 8, },
    {   3, 136 << 8,  64 << 8,   0, ROOM_22_SPRITE_128_64_OFS,   0, 120 << 8, 152 << 8,  128,   0,   3 << 8,  12 << 8,   6 << 8,  15 << 8, },
    {   3, 212 << 8,  64 << 8,   1, ROOM_22_SPRITE_192_64_OFS,   0, 192 << 8, 224 << 8,  128,   0,   3 << 8,  12 << 8,   6 << 8,  15 << 8, },
    {  14, 152 << 8, 160 << 8,   0, ROOM_22_SPRITE_416_40_OFS,   0,  88 << 8, 160 << 8,    0,   0,   4 << 8,  11 << 8,   4 << 8,  11 << 8, },
    {  14,  80 << 8, 160 << 8,   0, ROOM_22_SPRITE_416_40_OFS,   0,  48 << 8, 160 << 8,    0,   0,   4 << 8,  11 << 8,   4 << 8,  11 << 8, },
    {  14,  94 << 8, 160 << 8,   0, ROOM_22_SPRITE_416_40_OFS,   0,  56 << 8, 160 << 8,    0,   0,   4 << 8,  11 << 8,   4 << 8,  11 << 8, },
};

int32_t room_23_enemies[7][14] __attribute__((section(".drivers"))) = {
    {   3, 148 << 8,   8 << 8,   1, ROOM_23_SPRITE_352_64_OFS,   0,  16 << 8, 224 << 8,  128,   0,   1 << 8,  13 << 8,   0 << 8,  12 << 8, },
    {  14,  48 << 8, 160 << 8,   0, ROOM_23_SPRITE_416_40_OFS,   0,  12 << 8, 160 << 8,    0,   0,   4 << 8,  11 << 8,   4 << 8,  11 << 8, },
    {  14,  80 << 8, 160 << 8,   0, ROOM_23_SPRITE_416_40_OFS,   0,   8 << 8, 160 << 8,    0,   0,   4 << 8,  11 << 8,   4 << 8,  11 << 8, },
    {  14, 160 << 8, 160 << 8,   0, ROOM_23_SPRITE_416_40_OFS,   0,  10 << 8, 160 << 8,    0,   0,   4 << 8,  11 << 8,   4 << 8,  11 << 8, },
    {   6, 120 << 8,  32 << 8,   1, ROOM_23_SPRITE_464_24_OFS,   0,  16 << 8, 216 << 8,  153,   0,   1 << 8,  13 << 8,   2 << 8,  14 << 8, },
    {   6, 152 << 8, 104 << 8,   1, ROOM_23_SPRITE_464_24_OFS,   0,  16 << 8, 216 << 8,  153,   0,   1 << 8,  13 << 8,   2 << 8,  14 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};

int32_t room_24_enemies[7][14] __attribute__((section(".drivers"))) = {
    {  18, 200 << 8,  48 << 8,   0, 0,   0,  16 << 8,  80 << 8,    0,   0,   0 << 8,  32 << 8,   0 << 8,  48 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
    {   0,   0 << 8,   0 << 8,   0, 0,   0,   0 << 8,   0 << 8,    0,   0,   0 << 8,   0 << 8,   0 << 8,   0 << 8, },
};
