/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

uint32_t room[2];
uint32_t changeflag;
uint32_t counter[3];
int32_t proyec[24];

struct hero jean;
struct enem enemies[7];

extern int32_t room_01_enemies[7][14];
extern int32_t room_02_enemies[7][14];
extern int32_t room_03_enemies[7][14];
extern int32_t room_04_enemies[7][14];
extern int32_t room_05_enemies[7][14];
extern int32_t room_06_enemies[7][14];
extern int32_t room_07_enemies[7][14];
extern int32_t room_08_enemies[7][14];
extern int32_t room_09_enemies[7][14];
extern int32_t room_10_enemies[7][14];
extern int32_t room_11_enemies[7][14];
extern int32_t room_12_enemies[7][14];
extern int32_t room_13_enemies[7][14];
extern int32_t room_14_enemies[7][14];
extern int32_t room_15_enemies[7][14];
extern int32_t room_16_enemies[7][14];
extern int32_t room_17_enemies[7][14];
extern int32_t room_18_enemies[7][14];
extern int32_t room_19_enemies[7][14];
extern int32_t room_20_enemies[7][14];
extern int32_t room_21_enemies[7][14];
extern int32_t room_22_enemies[7][14];
extern int32_t room_23_enemies[7][14];
extern int32_t room_24_enemies[7][14];

void changescreen();
void collisions();
void contact();

void common_drawenemies();

void (*drawenemies)();
void (*events)();
void (*touchobj)();

void game(int * state)
{
    int r;
    uint32_t nes_bits;

    memset(video_ram, 0, sizeof(video_ram));
    memset(sprite_ram, 0, sizeof(sprite_ram));

    mailbox[0] = 0;
    mailbox[1] = 0;
    mailbox[2] = 0;
    hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 5, GPU_MAILBOX);

    room[0] = room[1] = 5;
    changeflag = 1;

    memset(&jean, 0, sizeof(jean));
    jean.x = 72 << 8;
    jean.y = 136 << 8;
    jean.direction = 1;
    jean.checkpoint[0] = 5;
    jean.checkpoint[1] = 72 << 8;
    jean.checkpoint[2] = 136 << 8;
    jean.checkpoint[3] = 5;
    jean.state[0] = 5;

    statusbar();

    for (;;) {
        // gamepad
        nes_bits = read_gamepad();

        /* Manage counters */
        if (counter[0] < 29)
            counter[0] ++;
        else
            counter[0] = 0;

        if (counter[1] < 90)
            counter[1] ++;
        else
            counter[1] = 0;

        if (counter[2] < 8)
            counter[2] ++;
        else
            counter[2] = 0;

        // vsync
        waitpeq(GPU_VSYNC, GPU_VSYNC);
        waitpne(GPU_VSYNC, GPU_VSYNC);

        changescreen();
        if (changeflag > 0) {
            counter[0] = 0;
            changeflag = 0;
        }

        if (room[0] == 24) {
            if (jean.flags[6] == 3)
                redparchment();
            else if (jean.flags[6] == 4) {
                //Mix_PlayChannel(-1, fx[2], 0);
                jean.flags[6] = 5;
                jean.direction = 0;
                //music (room,bso,&changeflag,jean.flags[6]);
            }
            else if (jean.flags[6] == 6) {
                blueparchment();
                jean.death = 0;
                changeflag = 1;
                room[0] = 4;
                jean.flags[6] = 7;
                jean.x = 125 << 8;
                jean.y = 115 << 8;
                jean.jump = 1;
            }
        }

        sprite_idx = 2;

        /* Draw Jean */
        if (jean.death == 0) {
            r = 0;
            if (jean.jump > 0) {
                r = 1;
                jean.animation = 0;
            }

            if (jean.ducking == 0) {
                sprite_ram[0] = ((jean.y & 0x1FF00) << 1) | ((jean.x & 0x1FF00) >> 8);
                sprite_ram[1] = GPU_TILES_RAM + SPRITE_320_88_OFS + ((jean.animation / 7) * 192) + (r * 384);
            }
            else {
                sprite_ram[0] = (((jean.y & 0x1FF00) + INC_8_0) << 1) | ((jean.x & 0x1FF00) >> 8);
                sprite_ram[1] = GPU_TILES_RAM + SPRITE_448_85_OFS + ((jean.animation / 7) * 192);
            }
            if (jean.direction)
                sprite_ram[0] |= MIRROR_FLAG;
        }

        /* Death animation */
        else if (jean.death > 0) {
            jean.death++;
            //Mix_PauseMusic ();
            if (jean.death == 2)
                ; // Mix_PlayChannel(-1, fx[6], 0);
            if ((jean.death < 8) || ((jean.death > 23) && (jean.death < 32)) || ((jean.death > 47) && (jean.death < 56))) {
                sprite_ram[1] = GPU_TILES_RAM + SPRITE_368_88_OFS;
            }
            else if (((jean.death > 7) && (jean.death < 16)) || ((jean.death > 31) && (jean.death < 40)) || ((jean.death > 55) && (jean.death < 64))) {
                sprite_ram[1] = GPU_TILES_RAM + SPRITE_536_88_OFS;
            }
            else {
                sprite_ram[1] = GPU_TILES_RAM + SPRITE_520_88_OFS;
            }
        }

        if (drawenemies != NULL) {
            drawenemies();
        }

        while(sprite_idx < 24) {
            sprite_ram[sprite_idx++] = 0;
        }
        hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 1, GPU_SPRITE_RAM);

        /* Jean management */
        if (jean.death == 0) {
            if (jean.flags[6] < 5) {
                if (jean.temp == 0) {
                    if ((nes_bits & (JOY_UP|JOY_A)) != 0) {
                        if ((jean.push[0] == 0) && (jean.jump == 0) && (jean.ducking == 0))
                            jean.jump = 1;
                    }
                    else {
                        jean.push[0] = 0;
                    }

                    if ((nes_bits & (JOY_DOWN|JOY_B)) != 0) {
                        if ((jean.push[1] == 0) && (jean.jump == 0)) {
                            jean.push[1] = 1;
                            jean.ducking = 1;
                        }
                    }
                    else {
                        jean.push[1] = 0;
                        jean.ducking = 0;
                    }

                    if ((nes_bits & JOY_LEFT) != 0) {
                        if (jean.push[2] == 0) {
                            jean.push[2] = 1;
                            jean.push[3] = 0;
                        }
                    }
                    else {
                        jean.push[2] = 0;
                    }

                    if ((nes_bits & JOY_RIGHT) != 0) {
                        if (jean.push[3] == 0) {
                            jean.push[3] = 1;
                            jean.push[2] = 0;
                        }
                    }
                    else {
                        jean.push[3] = 0;
                    }
                }
                if (jean.temp == 1)
                    jean.temp = 0;
                collisions();

                /* Jump */
                if (jean.jump == 1) {
                    if (jean.height == 0) /* Jump sound */
                        ; // Mix_PlayChannel(-1, fx[3], 0);
                    if (jean.height < INC_56_0) {
                        jean.height += INC_1_6;
                        if ((jean.collision[0] == 0) && (jean.height < INC_44_0))
                            jean.y -= INC_1_5;
                        jean.animation = 0;
                    }
                    else {
                        jean.jump = 2;
                        jean.collision[0] = 0;
                    }
                }

                /* Move to right */
                if (jean.push[3] == 1) {
                    jean.direction = 1;
                    if (jean.collision[3] == 0) {
                        if (jean.jump == 0) {
                          if (jean.animation < 13)
                                jean.animation ++;
                          else
                                jean.animation = 0;
                        }
                        if (jean.push[1] == 1)
                            jean.x += INC_0_30;
                        else
                            jean.x += INC_0_65;
                    }
                }

                /* Move to left */
                if (jean.push[2] == 1) {
                    jean.direction = 0;
                    if (jean.collision[2] == 0) {
                        if (jean.jump == 0) {
                          if (jean.animation < 13)
                                jean.animation ++;
                          else
                                jean.animation = 0;
                        }
                        if (jean.push[1] == 1)
                            jean.x -= INC_0_30;
                        else
                            jean.x -= INC_0_65;
                    }
                }
            }
            if (touchobj != NULL) {
                touchobj();
            }
            contact();
            if (room[0] == 4) {
                if (jean.temp < 7) {
                    /* Mover a Jean */
                    if (counter[1] == 45) {
                        switch (jean.direction) {
                            case 0:
                                jean.direction = 1;
                                break;
                            case 1:
                                jean.direction = 0;
                                break;
                        }
                        jean.temp++;
                    }
                } else {
                    jean.direction = 0;
                    jean.death = 1;
                }
            }
            else if (events != NULL)
                events();
        }

        /* Jean death */
        if (jean.death == 98) {
            if (room[0] != 4) {
                room[0] = jean.checkpoint[0];
                jean.x = jean.checkpoint[1];
                jean.y = jean.checkpoint[2];
                jean.jump = 0;
                jean.height = 0;
                jean.push[0] = 0;
                jean.push[1] = 0;
                jean.push[2] = 0;
                jean.push[3] = 0;
                changeflag = 2;
                jean.state[0] --;
                jean.death = 0;
                jean.temp = 1;
                statusbar();
                //music (room,bso,&changeflag,jean.flags[6]);
                //Mix_ResumeMusic ();
            }
            else {
                jean.death = 0;
                jean.flags[6] = 8;
            }
        }
        /* Using flag 6 as counter, to make time */
        if (jean.flags[6] > 7)
            jean.flags[6] ++;
        /* Reaching 15, jump to ending sequence */
        if (jean.flags[6] == 15) {
            *state = 4;
            return;
        }

        if (jean.state[0] == 0) {
            //Mix_HaltMusic();
            /* Mix_FreeMusic(sonido); */
            *state = 3;
            return;
        }
    }
}

void statusbar() {
    int i = 0;

    video_ram[22][0] = TILE401_ID;
    video_ram[22][1] = TILE401_ID + 1;
    video_ram[23][0] = TILE401_ID + 2;
    video_ram[23][1] = TILE401_ID + 3;

    i = NUM0_ID + jean.state[0];
    video_ram[22][2] = i;
    video_ram[23][2] = i + 10;

    video_ram[22][4] = TILE409_ID;
    video_ram[22][5] = TILE409_ID + 1;
    video_ram[23][4] = TILE409_ID + 2;
    video_ram[23][5] = TILE409_ID + 3;

    if (jean.state[1] >= 10) {
        i = NUM0_ID + (jean.state[1] / 10);
        video_ram[22][6] = i;
        video_ram[23][6] = i + 10;
        i = NUM0_ID + (jean.state[1] % 10);
        video_ram[22][7] = i;
        video_ram[23][7] = i + 10;
    }
    else {
        i = NUM0_ID + jean.state[1];
        video_ram[22][6] = i;
        video_ram[23][6] = i + 10;
        video_ram[22][7] = 0;
        video_ram[23][7] = 0;
    }
}

struct room_data rooms[25] = {
    { 0, 0, 0, NULL, NULL },
    { 0, 0, 0, NULL, NULL },
    { LOAD_EEPROM_OFFSET(room_02_enemies), GPU_ROOM_02_TILES_RAM, ROOM_02_TILESET_SIZE, common_drawenemies,     room_02_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_03_enemies), GPU_ROOM_03_TILES_RAM, ROOM_03_TILESET_SIZE, common_drawenemies,     room_03_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_04_enemies), 0,                     0,                    common_drawenemies,     NULL,             NULL },
    { LOAD_EEPROM_OFFSET(room_05_enemies), 0,                     0,                    room_05_06_drawenemies, NULL,             NULL },
    { LOAD_EEPROM_OFFSET(room_06_enemies), 0,                     0,                    room_05_06_drawenemies, room_06_touchobj, NULL },
    { 0, 0, 0, NULL, room_07_events },
    { LOAD_EEPROM_OFFSET(room_08_enemies), GPU_ROOM_08_TILES_RAM, ROOM_08_TILESET_SIZE, common_drawenemies,     room_08_touchobj, room_08_events },
    { LOAD_EEPROM_OFFSET(room_09_enemies), GPU_ROOM_09_TILES_RAM, ROOM_09_TILESET_SIZE, common_drawenemies,     room_09_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_10_enemies), GPU_ROOM_10_TILES_RAM, ROOM_10_TILESET_SIZE, dragon,                 room_10_touchobj, room_10_events },
    { LOAD_EEPROM_OFFSET(room_11_enemies), GPU_ROOM_11_TILES_RAM, ROOM_11_TILESET_SIZE, fireball,               room_11_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_12_enemies), GPU_ROOM_12_TILES_RAM, ROOM_12_TILESET_SIZE, common_drawenemies,     room_12_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_13_enemies), GPU_ROOM_13_TILES_RAM, ROOM_13_TILESET_SIZE, common_drawenemies,     room_13_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_14_enemies), GPU_ROOM_14_TILES_RAM, ROOM_14_TILESET_SIZE, plants,                 room_14_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_15_enemies), GPU_ROOM_15_TILES_RAM, ROOM_15_TILESET_SIZE, common_drawenemies,     room_15_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_16_enemies), GPU_ROOM_16_TILES_RAM, ROOM_16_TILESET_SIZE, common_drawenemies,     room_16_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_17_enemies), GPU_ROOM_17_TILES_RAM, ROOM_17_TILESET_SIZE, room_17_drawenemies,    room_17_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_18_enemies), GPU_ROOM_18_TILES_RAM, ROOM_18_TILESET_SIZE, death,                  room_18_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_19_enemies), GPU_ROOM_19_TILES_RAM, ROOM_19_TILESET_SIZE, common_drawenemies,     room_19_touchobj, room_19_events },
    { LOAD_EEPROM_OFFSET(room_20_enemies), GPU_ROOM_20_TILES_RAM, ROOM_20_TILESET_SIZE, room_20_drawenemies,    room_20_touchobj, room_20_events },
    { LOAD_EEPROM_OFFSET(room_21_enemies), GPU_ROOM_21_TILES_RAM, ROOM_21_TILESET_SIZE, room_20_drawenemies,    room_21_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_22_enemies), GPU_ROOM_22_TILES_RAM, ROOM_22_TILESET_SIZE, room_20_drawenemies,    room_22_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_23_enemies), GPU_ROOM_23_TILES_RAM, ROOM_23_TILESET_SIZE, common_drawenemies,     room_23_touchobj, NULL },
    { LOAD_EEPROM_OFFSET(room_24_enemies), GPU_ROOM_24_TILES_RAM, ROOM_24_TILESET_SIZE, room_24_drawenemies,    room_24_touchobj, room_24_events },
};

void changescreen()
{
    if ((jean.x < INC_1_0) && (room[0] != 5)) {
        room[1] = room[0];
        room[0] -= 1;
        jean.x = 239 << 8;
        changeflag = 1;
    }
    else if ((jean.x + INC_8_0) > INC_256_0) {
        room[1] = room[0];
        room[0] += 1;
        jean.x = 1 << 8;
        changeflag = 1;
    }
    else if ((jean.y + INC_12_0 < -INC_16_0) && (jean.jump == 1)) {
        room[1] = room[0];
        room[0] -= 5;
        jean.y = 152 << 8;
        changeflag = 1;
    }
    else if ((jean.y > INC_175_0) && (jean.jump != 1)) {
        room[1] = room[0];
        room[0] += 5;
        jean.y = -16 << 8;
        changeflag = 1;
    }

    if (changeflag) {
        memset(sprite_ram, 0, sizeof(sprite_ram));
        spi_read((room[0] - 1) * (MAP_SIZE), (uint8_t *) &video_ram[0][0], MAP_SIZE);
        hs_tx((sizeof(sprite_ram) + sizeof(video_ram)) / 4, (int32_t) sprite_ram, 0, GPU_SPRITE_RAM);
        if (rooms[room[0]].enemies_offs != 0)
            i2c_read_page(rooms[room[0]].enemies_offs, (uint8_t *) enemies, sizeof(enemies));
        else
            memset(enemies, 0, sizeof(enemies));

        drawenemies = rooms[room[0]].drawenemies;
        events = rooms[room[0]].events;
        touchobj = rooms[room[0]].touchobj;

        /* Load extended tileset */
        if (rooms[room[0]].tileset_size != 0) {
            mailbox[0] = rooms[room[0]].tiles_ram;
            mailbox[1] = rooms[room[0]].tileset_size;
            hs_tx(sizeof(mailbox) / 4, (int32_t) mailbox, 2, GPU_MAILBOX);
        }

        if (_room_ovl_table[room[0]][0] != 0) {
            i2c_read_page(LOAD_EEPROM_OFFSET(_room_ovl_table[room[0]][0]), _overlay_start, _room_ovl_table[room[0]][1]);
        }

        memset(proyec, 0, sizeof(proyec));
    }
}

void collisions()
{
    int blleft = 0;
    int blright = 0;
    int blground[4] = {0,0,0,0};
    int blroof[2] = {0,0};
    int points[8] = {0,0,0,0,0,0,0,0};
    int n = 0;
    int r = 0;

    points[0] = (jean.x + INC_1_0) / INC_8_0;
    points[1] = (jean.x + INC_7_0) / INC_8_0;
    points[2] = (jean.x + INC_8_0) / INC_8_0;
    points[3] = (jean.x + INC_13_0) / INC_8_0;
    points[4] = (jean.y + INC_1_0) / INC_8_0;
    points[5] = (jean.y + INC_8_0) / INC_8_0;
    points[6] = (jean.y + INC_15_0) / INC_8_0;
    points[7] = (jean.y + INC_23_0) / INC_8_0;

    jean.collision[0] = 0;
    jean.collision[1] = 0;
    jean.collision[2] = 0;
    jean.collision[3] = 0;

    /* Left & Right collisions */
    if (jean.ducking == 0) {
        for (n = 4; n < 8; n++) {
            if (((points[0] != 0) && (jean.direction == 0)) || ((points[3] != 31) && (jean.direction == 1))) {
                blleft = video_ram[points[n]][points[0] - 1];
                blright = video_ram[points[n]][points[3] + 1];
                if ((blleft > 0 && (blleft & WALL_FLAG) != 0 && blleft != TILE016_ID && blleft != TILE037_ID && blleft != TILE038_ID) || (video_ram[points[4]][points[0]] == TILE128_ID || blleft == TILE348_ID)) {
                    if (jean.x - ((points[0] - 1) * INC_8_0 + INC_7_0) < INC_1_1)
                        jean.collision[2] = 1;
                }
                if (blright > 0 && (blright & WALL_FLAG) != 0 && blright != TILE016_ID && blright != TILE037_ID && blright != TILE038_ID) {
                    if (((points[3] + 1) * INC_8_0) - (jean.x + INC_14_0) < INC_1_1)
                        jean.collision[3] = 1;
                }
            }
        }
    }

    /* Collision with Jean ducking */
    if (jean.ducking == 1) {
        if (((points[0] != 0) && (jean.direction == 0)) || ((points[3] != 31) && (jean.direction == 1))) {
            r = (jean.y + (16 << 8)) / INC_8_0;
            blleft = video_ram[r][points[0] - 1];
            blright = video_ram[r][points[3] + 1];
            if (((blleft & WALL_FLAG) != 0 && (blleft != TILE037_ID)) || ((video_ram[r][points[0]] == TILE128_ID) || ((blleft >= TILE347_ID) && (blleft <= TILE350_ID)))) {
                if (jean.x - (((points[0] - 1) * 8 + 7) << 8) < INC_1_1)
                    jean.collision[2] = 1;
            }
            if (((blright & WALL_FLAG) != 0 && (blright != TILE037_ID)) || ((blright >= TILE343_ID) && (blright <= TILE346_ID))) {
                if ((((points[3] + 1) * 8) << 8) - (jean.x + (14 << 8)) < INC_1_1)
                    jean.collision[3] = 1;
            }
        }
        /* Invisible wall */
        if ((room[0] == 11) && (r == 5)) {
            if ((points[0] - 1 == 0) || (points[0] - 1 == 1))
                jean.collision[2] = 0;
            if ((points[3] + 1 == 0) || (points[3] + 1 == 1))
                jean.collision[3] = 0;
        }
        else if ((room[0] == 10) && (r == 5)) {
            if ((points[0] - 1 > 27) && (points[0] - 1 < 32))
                jean.collision[2] = 0;
            if ((points[3] + 1 > 27) && (points[3] + 1 < 32))
                jean.collision[3] = 0;
        }
    }

    /* Touch ground collision */
    blground[0] = video_ram[points[7]+1][points[0]];
    blground[1] = video_ram[points[7]+1][points[1]];
    blground[2] = video_ram[points[7]+1][points[2]];
    blground[3] = video_ram[points[7]+1][points[3]];

    if (jean.jump != 1) {
        /* Invisible ground */
        if (((room[0] == 11) && (points[7]+1 > 19) && (points[0] == 2)) || ((room[0] == 16) && ((jean.y / 0x800) < 4) && (points[0] == 2))) {
            jean.y += GRAVITY;
            jean.jump = 2;
        }
        else {
            if ((blground[0] > 0 && (blground[0] & WALL_FLAG) != 0) || (blground[1] > 0 && (blground[1] & WALL_FLAG) != 0) || (blground[2] > 0 && (blground[2] & WALL_FLAG) != 0) || (blground[3] > 0 && (blground[3] & WALL_FLAG) != 0)) {
                jean.ground = (points[7] + 1) * 0x800;
                if (points[7] + 1 > 21) /* Dirty trick to make Jean go bottom of the screen */
                    jean.ground = 300 << 8;
                if ((jean.ground - INC_1_0) - (jean.y + INC_23_0) > INC_1_2)
                    jean.y += GRAVITY;
                else { /* Near ground */
                    jean.y += (jean.ground - INC_1_0) - (jean.y + INC_23_0);
                    jean.height = 0;
                    jean.jump = 0;
                    jean.flags[5] = 0;
                }
            }
            else {/* In air, ground near */
                jean.y += GRAVITY;
                jean.jump = 2;
            }
        }
    }

    /* Check small platforms */
    if (jean.direction == 0) {
        if ((blground[3] == TILE038_ID) && ((jean.x + INC_13_0) < ((points[3] * INC_8_0) + INC_5_0)) && (jean.push[2] == 1) && (jean.jump ==0)) {
            jean.y += GRAVITY;
            jean.jump = 2;
        }
    }
    else if (jean.direction == 1) {
        if ((blground[0] == TILE038_ID) && ((jean.x + INC_1_0) > ((points[0] + 2) << 8)) && (jean.push[3] == 1) && (jean.jump == 0)) {
            jean.y += GRAVITY;
            jean.jump = 2;
        }
    }

    /* Touch roof collision */
    blroof[0] = video_ram[points[4]-1][points[0]];
    blroof[1] = video_ram[points[4]-1][points[3]];

    if ((jean.jump == 1) && (points[4] > 0)) {
        if ((blroof[0] > 0 && (blroof[0] & WALL_FLAG) != 0 && blroof[0] != TILE016_ID && blroof[0] != TILE037_ID && blroof[0] != TILE038_ID) || (blroof[1] > 0 && (blroof[1] & WALL_FLAG) != 0 && blroof[1] != TILE016_ID && blroof[1] != TILE037_ID && blroof[1] != TILE038_ID)) {
            if ((jean.y - INC_1_0) - ((points[4] - 1) * 0x800 + INC_7_0) < INC_1_0)
                jean.collision[0] = 1;
        }
    }
}

void contact()
{
    int i = 0;
    int points[4] = { 0, 0, 0, 0 }; /* 4 points of collision of enemy sprite */
    int x = 0;
    int y = 0;

    /* Collisions with enemies */
    for (i = 0; i < 7; i++) {
        if (((enemies[i].type > 0) && (enemies[i].type != 12)) || ((enemies[i].type == 12) && (enemies[i].y > enemies[i].limleft + INC_8_0))) {
            /* Setting points of collision... */
            points[0] = enemies[i].x + enemies[i].adjustx1;
            points[1] = enemies[i].x + enemies[i].adjustx2;
            points[2] = enemies[i].y + enemies[i].adjusty1;
            points[3] = enemies[i].y + enemies[i].adjusty2;
            /* Checking... */
            for (x = points[0]; x <= points[1]; x += INC_1_0) {
                if ((x > jean.x + INC_1_0) && (x < jean.x + INC_13_0)) {
                    for (y = points[2]; y <= points[3]; y += INC_1_0) {
                        if ((y > jean.y + (jean.ducking * INC_8_0)) && (y < jean.y + INC_22_0)) {
                            if (jean.flags[6] < 5) {
                                jean.death = 1;
                                y = points[3] + INC_1_0;
                                x = points[1] + INC_1_0;
                            } else {
                                /* Mix_HaltMusic (); */
                                jean.flags[6] = 6;
                            }
                        }
                    }
                }
            }

        }
    }

    /* Collision with shoots */
    for (i = 0; i < 3; i++) {
        if (proyec[i * 2] > 0) {
            /* Setting points of collision */
            if (enemies[i].type == 11) { /* Gargoyle */
                points[0] = proyec[i * 2];
                points[1] = proyec[i * 2] + INC_10_0;
                points[2] = enemies[i].y + INC_10_0;
                points[3] = enemies[i].y + INC_12_0;
            }
            else if (enemies[i].type == 15) { /* Archers */
                points[0] = proyec[i * 2] + INC_3_0;
                points[1] = proyec[i * 2] + INC_7_0;
                points[2] = enemies[i].y + INC_10_0;
                points[3] = enemies[i].y + INC_17_0;
            }

            for (x = points[0]; x <= points[1]; x += INC_1_0) {
                if ((x > jean.x + INC_3_0) && (x < jean.x + INC_13_0)) {
                    for (y = points[2]; y <= points[3]; y += INC_1_0) {
                        if ((y > (jean.y + INC_5_0 + (jean.ducking * INC_8_0))) && (y < jean.y + INC_22_0)) {
                            jean.death = 1;
                            y = points[3] + INC_1_0;
                            x = points[1] + INC_1_0;
                        }
                    }
                }
            }
        }
    }

    /* Check collision with plants shoots, dragon, death and Satan */
    if ((room[0] == 10) || (room[0] == 14) || (room[0] == 18) || (room[0] == 24)) {
        for (i = 0; i < 23; i += 2) {
            if (proyec[i] > 0) {
                if (room[0] == 18) {
                    points[0] = proyec[i + 1];
                    points[1] = proyec[i + 1] + INC_15_0;
                    points[2] = proyec[i];
                    points[3] = proyec[i] + INC_15_0;
                }
                else if ((room[0] == 14) || (room[0] == 24)) {
                    points[0] = proyec[i];
                    points[1] = proyec[i] + INC_3_0;
                    points[2] = proyec[i + 1];
                    points[3] = proyec[i + 1] + INC_3_0;
                }
                else if (room[0] == 10) {
                    points[0] = proyec[i];
                    points[1] = proyec[i] + INC_8_0;
                    points[2] = 88 << 8;
                    points[3] = 96 << 8;
                }

                for (x = points[0]; x <= points[1]; x += INC_1_0) {
                    if ((x > jean.x + INC_1_0) && (x < jean.x + INC_13_0)) {
                        for (y = points[2]; y <= points[3]; y += INC_1_0) {
                            if ((y > jean.y + (jean.ducking * INC_8_0)) && (y < jean.y + INC_22_0)) {
                                jean.death = 1;
                                y = points[3] + INC_1_0;
                                x = points[1] + INC_1_0;
                                i = 17;
                            }
                        }
                    }
                }
            }
        }
    }

    //jean.death = 0;
}

#define SPRITE_SIZE(s) (((s >> 16) & 0x38) * ((s >> 19) & 0x38) / 2)

void common_drawenemies()
{
    int i, n;
    uint32_t sprite0 = 0, sprite1 = 0;

    for (i = 0; i < 7; i++) {
        if ((enemies[i].type > 0) && (enemies[i].type < 16)) {
            sprite0 = ((enemies[i].y & 0x1FF00) << 1) | ((enemies[i].x & 0x1FF00) >> 8);

            if (room[0] == 4) {
                if (enemies[i].direction == 0)
                    sprite0 |= MIRROR_FLAG;
            }
            else if (enemies[i].type < 10) {
                if (enemies[i].direction == 0) { /* Go right */
                    if ((enemies[i].x + INC_1_0) < enemies[i].limright)
                        enemies[i].x += enemies[i].speed;
                    else {
                        enemies[i].direction = 1;
                    }
                }
                else if (enemies[i].direction == 1) { /* Go left */
                    if ((enemies[i].x - INC_1_0) > enemies[i].limleft)
                        enemies[i].x -= enemies[i].speed;
                    else {
                        enemies[i].direction = 0;
                    }
                }
                else if (enemies[i].direction == 2) { /* Go up */
                    if ((enemies[i].y - INC_1_0) > enemies[i].limleft)
                        enemies[i].y -= enemies[i].speed;
                    else {
                        enemies[i].direction = 3;
                    }
                }
                else if (enemies[i].direction == 3) { /* Go down */
                    if ((enemies[i].y + INC_1_0) < enemies[i].limright)
                        enemies[i].y += enemies[i].speed;
                    else {
                        enemies[i].direction = 2;
                    }
                }

                /* Animation */
                if (((counter[0] == 1) || (counter[0] == 11) || (counter[0] == 21)) && (enemies[i].type != 5)){
                    if (enemies[i].animation == 0)
                        enemies[i].animation = 1;
                    else
                        enemies[i].animation = 0;
                }

                if (enemies[i].type == 4 && enemies[i].direction == 2)
                    sprite0 |= MIRROR_FLAG;
                else if (enemies[i].direction == 0)
                    sprite0 |= MIRROR_FLAG;
            }

            /* Enemy's shoots */
            if ((enemies[i].type == 15) || (enemies[i].type == 11)) {
                if ((enemies[i].type == 15) && (enemies[i].speed == 0)) { /* Move enemies looking at Jean */
                    if ((jean.x + (23 << 8)) < (enemies[i].x)) {
                        enemies[i].direction = 1;
                    }
                    else if (jean.x > (enemies[i].x + (16 << 8))) {
                        enemies[i].direction = 0;
                    }
                }
                if (enemies[i].direction == 0) {
                    sprite0 |= MIRROR_FLAG;
                }
                if (i == 0) {
                    if (enemies[i].speed < 55) {
                        enemies[i].speed++;
                        enemies[i].animation = 1;
                    }
                    else
                        enemies[i].animation = 0;
                }
                else {
                    enemies[i].speed = enemies[0].speed;
                    enemies[i].animation = enemies[0].animation;
                }

                /* Enable fire */
                if (enemies[i].speed == 50) {
                    for (n = 0; n <= 4; n += 2) {
                        if (proyec[n] == 0) {
                            enemies[i].fire = 1;
                            if (enemies[i].direction == 1)
                                proyec[n] = enemies[i].x - INC_8_0;
                            else
                                proyec[n] = enemies[i].x + INC_8_0;
                            if (n > 0)
                                proyec[n + 1] = i;
                            n = 5;
                            //Mix_PlayChannel(-1, fx[0], 0);
                        }
                    }
                }
            }

            if (enemies[i].type == 12) { /* Water drop */
                if (enemies[i].speed < 60)
                    enemies[i].speed++; /* Using speed like counter */
                sprite1 = GPU_TILES_RAM + enemies[i].tile + ((enemies[i].speed / 30) * 128);
                if (enemies[i].speed >= 60) {
                    if (enemies[i].y < (enemies[i].limright - INC_8_0))
                        enemies[i].y += INC_0_9;
                    else { /* Reboot drop */
                        enemies[i].y = enemies[i].limleft; /* Using limleft like drop start */
                        enemies[i].speed = 0;
                    }
                }
            }
            else if (enemies[i].tile != 0) {
                sprite1 = GPU_TILES_RAM + enemies[i].tile + SPRITE_SIZE(enemies[i].tile) * enemies[i].animation;
            }

            if ((enemies[i].type == 13) || (enemies[i].type == 14)) { /* Fireballs & fishes */
                if ((counter[0] == 1) || (counter[0] == 11) || (counter[0] == 21)) {
                    if (enemies[i].animation == 0)
                        enemies[i].animation = 1;
                    else
                        enemies[i].animation = 0;
                }
                if (enemies[i].direction == 0) { /* Fireball going up */
                    if (enemies[i].y == (enemies[i].limright)) {
                        if (enemies[i].speed < 45) /* Temp */
                            enemies[i].speed++;
                        else
                            enemies[i].y -= INC_1_0;
                    } else {
                        if (enemies[i].y > (enemies[i].limleft + INC_16_0))
                            enemies[i].y -= INC_2_0;
                        else
                            enemies[i].y -= INC_1_0;
                    }
                    if (enemies[i].y == enemies[i].limleft + INC_8_0)
                        enemies[i].direction = 1;
                } else {
                    if (enemies[i].y != enemies[i].limright)
                        enemies[i].y += INC_2_0;
                    else { /* Reboot */
                        enemies[i].speed = 0;
                        enemies[i].direction = 0;
                    }
                }
            }

            sprite_ram[sprite_idx++] = sprite0;
            sprite_ram[sprite_idx++] = sprite1;
        }
    }
}
