/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#ifndef GRAPHICS_H_
#define GRAPHICS_H_

#define WIDTH_8                 (1 << 19)
#define WIDTH_16                (2 << 19)
#define WIDTH_24                (3 << 19)
#define WIDTH_32                (4 << 19)

#define HEIGHT_8                (1 << 22)
#define HEIGHT_16               (2 << 22)
#define HEIGHT_24               (3 << 22)
#define HEIGHT_32               (4 << 22)

#define TILE002_ID              0x8001
#define TILE003_ID              0x8002
#define TILE004_ID              0x8003
#define TILE005_ID              0x8004
#define TILE006_ID              0x8005
#define TILE007_ID              0x8006
#define TILE008_ID              0x8007
#define TILE009_ID              0x8008
#define TILE010_ID              0x8009
#define TILE011_ID              0x800A
#define TILE012_ID              0x800B
#define TILE013_ID              0x800C
#define TILE014_ID              0x800D
#define TILE015_ID              0x800E
#define TILE016_ID              0x800F
#define TILE017_ID              0x8010
#define TILE018_ID              0x8011
#define TILE020_ID              0x8012
#define TILE021_ID              0x8013
#define TILE022_ID              0x8014
#define TILE023_ID              0x8015
#define TILE024_ID              0x8016
#define TILE025_ID              0x8017
#define TILE026_ID              0x8018
#define TILE027_ID              0x8019
#define TILE028_ID              0x801A
#define TILE030_ID              0x801B
#define TILE032_ID              0x801C
#define TILE033_ID              0x801D
#define TILE034_ID              0x801E
#define TILE035_ID              0x801F
#define TILE036_ID              0x8020
#define TILE037_ID              0x8021
#define TILE038_ID              0x8022
#define TILE039_ID              0x8023
#define TILE040_ID              0x8024
#define TILE041_ID              0x8025
#define TILE042_ID              0x8026
#define TILE043_ID              0x8027
#define TILE044_ID              0x8028
#define TILE046_ID              0x8029
#define TILE047_ID              0x802A
#define TILE048_ID              0x802B
#define TILE049_ID              0x802C
#define TILE050_ID              0x802D
#define TILE051_ID              0x802E
#define TILE052_ID              0x802F
#define TILE053_ID              0x8030
#define TILE054_ID              0x8031
#define TILE055_ID              0x8032
#define TILE056_ID              0x8033
#define TILE057_ID              0x8034
#define TILE058_ID              0x8035
#define TILE059_ID              0x8036
#define TILE060_ID              0x8037
#define TILE062_ID              0x8038
#define TILE063_ID              0x8039
#define TILE064_ID              0x803A
#define TILE065_ID              0x803B
#define TILE066_ID              0x803C
#define TILE068_ID              0x803D
#define TILE069_ID              0x803E
#define TILE070_ID              0x803F
#define TILE071_ID              0x8040
#define TILE072_ID              0x8041
#define TILE073_ID              0x8042
#define TILE074_ID              0x8043
#define TILE075_ID              0x8044
#define TILE084_ID              0x8445
#define TILE101_ID              0x0446
#define TILE102_ID              0x0447
#define TILE104_ID              0x0448
#define TILE106_ID              0x0449
#define TILE107_ID              0x044A
#define TILE108_ID              0x044B
#define TILE109_ID              0x044C
#define TILE110_ID              0x044D
#define TILE111_ID              0x044E
#define TILE112_ID              0x044F
#define TILE113_ID              0x0450
#define TILE114_ID              0x0451
#define TILE115_ID              0x0452
#define TILE116_ID              0x0453
#define TILE117_ID              0x0454
#define TILE118_ID              0x0455
#define TILE119_ID              0x0456
#define TILE121_ID              0x0457
#define TILE122_ID              0x0458
#define TILE123_ID              0x0459
#define TILE124_ID              0x045A
#define TILE126_ID              0x045B
#define TILE127_ID              0x045C
#define TILE128_ID              0x045D
#define TILE129_ID              0x045E
#define TILE130_ID              0x045F
#define TILE131_ID              0x0460
#define TILE132_ID              0x0461
#define TILE133_ID              0x0462
#define TILE134_ID              0x0463
#define TILE135_ID              0x0464
#define TILE136_ID              0x0465
#define TILE137_ID              0x0466
#define TILE138_ID              0x0467
#define TILE139_ID              0x0468
#define TILE142_ID              0x0469
#define TILE143_ID              0x046A
#define TILE144_ID              0x046B
#define TILE145_ID              0x046C
#define TILE146_ID              0x046D
#define TILE147_ID              0x046E
#define TILE149_ID              0x046F
#define TILE150_ID              0x0470
#define TILE151_ID              0x0471
#define TILE152_ID              0x0472
#define TILE153_ID              0x0473
#define TILE154_ID              0x0474
#define TILE154_1_ID            0x0475
#define TILE154_2_ID            0x0476
#define TILE154_3_ID            0x0477
#define TILE154_4_ID            0x0478
#define TILE154_5_ID            0x0479
#define TILE201_1_ID            0x047A
#define TILE201_2_ID            0x047B
#define TILE201_3_ID            0x047C
#define TILE201_4_ID            0x047D
#define TILE201_6_ID            0x047E
#define TILE201_7_ID            0x047F
#define TILE201_8_ID            0x0480
#define TILE201_9_ID            0x0481
#define TILE201_10_ID           0x0482
#define TILE201_11_ID           0x0483
#define TILE201_12_ID           0x0484
#define TILE201_13_ID           0x0485
#define TILE201_14_ID           0x0486
#define TILE201_15_ID           0x0487
#define TILE201_16_ID           0x0488
#define TILE201_17_ID           0x0489
#define TILE201_18_ID           0x048A
#define TILE201_19_ID           0x048B
#define TILE201_20_ID           0x048C
#define TILE201_21_ID           0x048D
#define TILE201_22_ID           0x048E
#define TILE201_23_ID           0x048F
#define TILE201_24_ID           0x0490
#define TILE201_25_ID           0x0491
#define TILE201_26_ID           0x0492
#define TILE201_27_ID           0x0493
#define TILE201_28_ID           0x0494
#define TILE201_29_ID           0x0495
#define TILE201_31_ID           0x0496
#define TILE201_32_ID           0x0497
#define TILE201_33_ID           0x0498
#define TILE201_34_ID           0x0499
#define TILE202_ID              0x049A
#define TILE202_1_ID            0x049B
#define TILE202_2_ID            0x049C
#define TILE202_3_ID            0x049D
#define TILE202_4_ID            0x049E
#define TILE202_5_ID            0x049F
#define TILE202_6_ID            0x04A0
#define TILE202_7_ID            0x04A1
#define TILE202_8_ID            0x04A2
#define TILE202_9_ID            0x04A3
#define TILE202_10_ID           0x04A4
#define TILE202_11_ID           0x04A5
#define TILE202_12_ID           0x04A6
#define TILE202_13_ID           0x04A7
#define TILE202_14_ID           0x04A8
#define TILE202_15_ID           0x04A9
#define TILE202_16_ID           0x04AA
#define TILE202_17_ID           0x04AB
#define TILE202_18_ID           0x04AC
#define TILE202_19_ID           0x04AD
#define TILE202_20_ID           0x04AE
#define TILE202_21_ID           0x04AF
#define TILE202_22_ID           0x04B0
#define TILE202_23_ID           0x04B1
#define TILE202_24_ID           0x04B2
#define TILE202_25_ID           0x04B3
#define TILE202_26_ID           0x04B4
#define TILE202_27_ID           0x04B5
#define TILE202_28_ID           0x04B6
#define TILE202_29_ID           0x04B7
#define TILE202_30_ID           0x04B8
#define TILE202_31_ID           0x04B9
#define TILE202_32_ID           0x04BA
#define TILE202_33_ID           0x04BB
#define TILE202_34_ID           0x04BC
#define TILE202_35_ID           0x04BD
#define TILE301_ID              0x04BE
#define TILE302_ID              0x04BF
#define TILE303_ID              0x04C0
#define TILE304_ID              0x04C1
#define TILE305_ID              0x04C2
#define TILE306_ID              0x04C3
#define TILE307_ID              0x04C4
#define TILE308_ID              0x04C5
#define TILE309_ID              0x08C6
#define TILE311_ID              0x08C7
#define TILE312_ID              0x08C8
#define TILE314_ID              0x08C9
#define TILE315_ID              0x08CA
#define TILE316_ID              0x08CB
#define TILE317_ID              0x08CC
#define TILE318_ID              0x08CD
#define TILE319_ID              0x08CE
#define TILE320_ID              0x08CF
#define TILE321_ID              0x08D0
#define TILE322_ID              0x08D1
#define TILE323_ID              0x08D2
#define TILE324_ID              0x08D3
#define TILE325_ID              0x08D4
#define TILE326_ID              0x08D5
#define TILE327_ID              0x08D6
#define TILE328_ID              0x08D7
#define TILE329_ID              0x08D8
#define TILE330_ID              0x08D9
#define TILE331_ID              0x08DA
#define TILE332_ID              0x08DB
#define TILE333_ID              0x08DC
#define TILE334_ID              0x08DD
#define TILE335_ID              0x08DE
#define TILE336_ID              0x08DF
#define TILE337_ID              0x08E0
#define TILE338_ID              0x08E1
#define TILE339_ID              0x08E2
#define TILE340_ID              0x08E3
#define TILE341_ID              0x08E4
#define TILE342_ID              0x08E5
#define TILE343_ID              0x88E6
#define TILE344_ID              0x88E7
#define TILE345_ID              0x88E8
#define TILE346_ID              0x88E9
#define TILE347_ID              0x88EA
#define TILE348_ID              0x88EB
#define TILE349_ID              0x88EC
#define TILE350_ID              0x88ED
#define TILE401_ID              0x08EE
#define TILE402_ID              0x08EF
#define TILE403_ID              0x08F0
#define TILE404_ID              0x08F1
#define TILE405_ID              0x08F2
#define TILE406_ID              0x08F3
#define TILE407_ID              0x08F4
#define TILE408_ID              0x08F5
#define TILE409_ID              0x08F6
#define TILE410_ID              0x08F7
#define TILE411_ID              0x08F8
#define TILE412_ID              0x08F9
#define TILE413_ID              0x08FA
#define TILE414_ID              0x08FB
#define TILE415_ID              0x08FC
#define TILE416_ID              0x08FD
#define TILE425_ID              0x08FE
#define TILE426_ID              0x08FF
#define TILE427_ID              0x0900
#define TILE428_ID              0x0901
#define TILE501_ID              0x0902
#define TILE502_ID              0x0903
#define TILE503_ID              0x0904
#define TILE504_ID              0x0905
#define TILE602_ID              0x0D06
#define TILE603_ID              0x0D07
#define TILE604_ID              0x0D08
#define TILE605_ID              0x0D09
#define TILE607_ID              0x0D0A
#define TILE608_ID              0x0D0B
#define TILE609_ID              0x0D0C
#define TILE610_ID              0x0D0D
#define TILE611_ID              0x0D0E
#define TILE612_ID              0x0D0F
#define TILE613_ID              0x0D10
#define TILE614_ID              0x0D11
#define TILE615_ID              0x0D12
#define TILE617_ID              0x0D13
#define TILE618_ID              0x0D14
#define TILE619_ID              0x0D15
#define TILE620_ID              0x0D16
#define TILE621_ID              0x0D17
#define TILE622_ID              0x0D18
#define TILE623_ID              0x0D19
#define TILE624_ID              0x0D1A
#define TILE625_ID              0x0D1B
#define TILE626_ID              0x0D1C
#define TILE627_ID              0x0D1D
#define TILE628_ID              0x0D1E
#define TILE629_ID              0x0D1F
#define TILE630_ID              0x0D20
#define TILE631_ID              0x0D21
#define TILE632_ID              0x0D22
#define TILE633_ID              0x0D23
#define TILE634_ID              0x0D24
#define TILE635_ID              0x0D25
#define TILE636_ID              0x0D26
#define TILE637_ID              0x0D27
#define TILE638_ID              0x0D28
#define TILE639_ID              0x0D29
#define TILE640_ID              0x0D2A
#define TILE650_ID              0x092D
#define TILE650_1_ID            0x092E
#define TILE650_2_ID            0x052F
#define TILE650_3_ID            0x0530

#define NUM0_ID                 0x0131

#define SPRITE_320_88_OFS       (WIDTH_16 | HEIGHT_24 | 0x600028A0)
#define SPRITE_336_88_OFS       (WIDTH_16 | HEIGHT_24 | 0x60002960)
#define SPRITE_352_88_OFS       (WIDTH_16 | HEIGHT_24 | 0x60002A20)
#define SPRITE_448_85_OFS       (WIDTH_24 | HEIGHT_16 | 0x60002AE0)
#define SPRITE_466_85_OFS       (WIDTH_24 | HEIGHT_16 | 0x60002BA0)
#define SPRITE_368_88_OFS       (WIDTH_16 | HEIGHT_24 | 0x60002C60)
#define SPRITE_520_88_OFS       (WIDTH_16 | HEIGHT_24 | 0x60002D20)
#define SPRITE_536_88_OFS       (WIDTH_16 | HEIGHT_24 | 0x60002DE0)
#define SPRITE_64_64_OFS        (WIDTH_16 | HEIGHT_24 | 0x60002EA0)
#define SPRITE_80_64_OFS        (WIDTH_16 | HEIGHT_24 | 0x60002F60)

#define OVERLAY_START           3080 // longs, 12320 (3020) bytes

#define ROOM_02_SPRITE_96_40_OFS    (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_02_SPRITE_112_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_02_TILESET_SIZE        256 // bytes

#define ROOM_03_SPRITE_160_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_03_SPRITE_176_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_03_SPRITE_192_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003120)
#define ROOM_03_SPRITE_208_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800031A0)
#define ROOM_03_TILESET_SIZE        512 // bytes

#define ROOM_08_SPRITE_224_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_08_SPRITE_240_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_08_TILESET_SIZE        256 // bytes

#define ROOM_09_SPRITE_320_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003020)
#define ROOM_09_SPRITE_512_48_OFS   (WIDTH_16 | HEIGHT_8 | 0x800030E0)
#define ROOM_09_SPRITE_528_48_OFS   (WIDTH_16 | HEIGHT_8 | 0x80003120)
#define ROOM_09_TILESET_SIZE        320 // bytes

#define ROOM_10_SPRITE_464_0_OFS    (WIDTH_8 | HEIGHT_8 | 0x80003020)
#define ROOM_10_SPRITE_472_0_OFS    (WIDTH_8 | HEIGHT_8 | 0x80003040)
#define ROOM_10_SPRITE_416_56_OFS   (WIDTH_32 | HEIGHT_24 | 0x80003060)
#define ROOM_10_SPRITE_448_56_OFS   (WIDTH_32 | HEIGHT_16 | 0x800031E0)
#define ROOM_10_SPRITE_504_56_OFS   (WIDTH_24 | HEIGHT_24 | 0x800032E0)
#define ROOM_10_SPRITE_480_56_OFS   (WIDTH_24 | HEIGHT_24 | 0x80003400)
#define ROOM_10_SPRITE_552_56_OFS   (WIDTH_24 | HEIGHT_24 | 0x80003520)
#define ROOM_10_SPRITE_528_56_OFS   (WIDTH_24 | HEIGHT_24 | 0x80003640)
#define ROOM_10_TILESET_SIZE        1856 // bytes

#define ROOM_11_SPRITE_576_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_11_SPRITE_592_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_11_TILESET_SIZE        256 // bytes

#define ROOM_12_SPRITE_560_24_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_12_SPRITE_576_24_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_12_SPRITE_256_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003120)
#define ROOM_12_SPRITE_272_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800031A0)
#define ROOM_12_TILESET_SIZE        512 // bytes

#define ROOM_13_SPRITE_128_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003020)
#define ROOM_13_SPRITE_144_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600030E0)
#define ROOM_13_TILESET_SIZE        384 // bytes

#define ROOM_14_SPRITE_680_32_OFS   (WIDTH_8 | HEIGHT_8 | 0x80003020)
#define ROOM_14_SPRITE_160_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003040)
#define ROOM_14_SPRITE_176_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030C0)
#define ROOM_14_SPRITE_384_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003140)
#define ROOM_14_SPRITE_400_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800031C0)
#define ROOM_14_SPRITE_512_48_OFS   (WIDTH_16 | HEIGHT_8 | 0x80003240)
#define ROOM_14_SPRITE_528_48_OFS   (WIDTH_16 | HEIGHT_8 | 0x80003280)
#define ROOM_14_TILESET_SIZE        672 // bytes

#define ROOM_15_SPRITE_640_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_15_SPRITE_656_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_15_SPRITE_672_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003120)
#define ROOM_15_SPRITE_0_64_OFS     (WIDTH_16 | HEIGHT_24 | 0x600031A0)
#define ROOM_15_SPRITE_16_64_OFS    (WIDTH_16 | HEIGHT_24 | 0x60003260)
#define ROOM_15_TILESET_SIZE        768 // bytes

#define ROOM_16_SPRITE_448_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_16_SPRITE_464_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_16_SPRITE_160_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003120)
#define ROOM_16_SPRITE_176_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800031A0)
#define ROOM_16_SPRITE_480_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003220)
#define ROOM_16_SPRITE_496_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800032A0)
#define ROOM_16_TILESET_SIZE        768 // bytes

#define ROOM_17_SPRITE_624_24_OFS   (WIDTH_16 | HEIGHT_8 | 0x80003020)
#define ROOM_17_SPRITE_256_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003060)
#define ROOM_17_SPRITE_272_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003120)
#define ROOM_17_TILESET_SIZE        448 // bytes

#define ROOM_18_SPRITE_0_88_OFS     (WIDTH_32 | HEIGHT_32 | 0x80003020)
#define ROOM_18_SPRITE_32_88_OFS    (WIDTH_32 | HEIGHT_32 | 0x80003220)
#define ROOM_18_SPRITE_64_88_OFS    (WIDTH_32 | HEIGHT_32 | 0x80003420)
#define ROOM_18_SPRITE_576_56_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003620)
#define ROOM_18_SPRITE_592_56_OFS   (WIDTH_16 | HEIGHT_16 | 0x800036A0)
#define ROOM_18_SPRITE_608_56_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003720)
#define ROOM_18_SPRITE_624_56_OFS   (WIDTH_16 | HEIGHT_16 | 0x800037A0)
#define ROOM_18_TILESET_SIZE        2048 // bytes

#define ROOM_19_SPRITE_640_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_19_SPRITE_656_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_19_SPRITE_672_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003120)
#define ROOM_19_SPRITE_480_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800031A0)
#define ROOM_19_SPRITE_496_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003220)
#define ROOM_19_SPRITE_160_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800032A0)
#define ROOM_19_SPRITE_176_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003320)
#define ROOM_19_TILESET_SIZE        896 // bytes

#define ROOM_20_SPRITE_448_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_20_SPRITE_464_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_20_SPRITE_0_64_OFS     (WIDTH_16 | HEIGHT_24 | 0x60003120)
#define ROOM_20_SPRITE_16_64_OFS    (WIDTH_16 | HEIGHT_24 | 0x600031E0)
#define ROOM_20_SPRITE_464_24_OFS   (WIDTH_24 | HEIGHT_16 | 0x800032A0)
#define ROOM_20_SPRITE_488_24_OFS   (WIDTH_24 | HEIGHT_16 | 0x80003360)
#define ROOM_20_SPRITE_656_24_OFS   (WIDTH_16 | HEIGHT_8 | 0x80003420)
#define ROOM_20_TILESET_SIZE        1088 // bytes

#define ROOM_21_SPRITE_256_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003020)
#define ROOM_21_SPRITE_272_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600030E0)
#define ROOM_21_SPRITE_192_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600031A0)
#define ROOM_21_SPRITE_208_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003260)
#define ROOM_21_SPRITE_624_24_OFS   (WIDTH_16 | HEIGHT_8 | 0x80003320)
#define ROOM_21_TILESET_SIZE        832 // bytes

#define ROOM_22_SPRITE_448_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003020)
#define ROOM_22_SPRITE_464_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800030A0)
#define ROOM_22_SPRITE_352_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003120)
#define ROOM_22_SPRITE_368_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600031E0)
#define ROOM_22_SPRITE_128_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600032A0)
#define ROOM_22_SPRITE_144_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003360)
#define ROOM_22_SPRITE_192_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003420)
#define ROOM_22_SPRITE_208_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600034E0)
#define ROOM_22_SPRITE_416_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800035A0)
#define ROOM_22_SPRITE_432_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003620)
#define ROOM_22_SPRITE_656_24_OFS   (WIDTH_16 | HEIGHT_8 | 0x800036A0)
#define ROOM_22_TILESET_SIZE        1728 // bytes

#define ROOM_23_SPRITE_352_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x60003020)
#define ROOM_23_SPRITE_368_64_OFS   (WIDTH_16 | HEIGHT_24 | 0x600030E0)
#define ROOM_23_SPRITE_416_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x800031A0)
#define ROOM_23_SPRITE_432_40_OFS   (WIDTH_16 | HEIGHT_16 | 0x80003220)
#define ROOM_23_SPRITE_464_24_OFS   (WIDTH_24 | HEIGHT_16 | 0x800032A0)
#define ROOM_23_SPRITE_488_24_OFS   (WIDTH_24 | HEIGHT_16 | 0x80003360)
#define ROOM_23_TILESET_SIZE        1024 // bytes

#define ROOM_24_SPRITE_680_32_OFS   (WIDTH_8 | HEIGHT_8 | 0x80003020)
#define ROOM_24_SPRITE_192_88_OFS   (WIDTH_32 | HEIGHT_24 | 0x80003040)
#define ROOM_24_SPRITE_224_88_OFS   (WIDTH_32 | HEIGHT_24 | 0x800031C0)
#define ROOM_24_SPRITE_256_88_OFS   (WIDTH_32 | HEIGHT_24 | 0x80003340)
#define ROOM_24_SPRITE_288_88_OFS   (WIDTH_32 | HEIGHT_24 | 0x800034C0)
#define ROOM_24_SPRITE_696_0_OFS    (WIDTH_32 | HEIGHT_24 | 0x80003640)
#define ROOM_24_SPRITE_696_24_OFS   (WIDTH_32 | HEIGHT_24 | 0x800037C0)
#define ROOM_24_SPRITE_728_0_OFS    (WIDTH_32 | HEIGHT_24 | 0x80003940)
#define ROOM_24_SPRITE_728_24_OFS   (WIDTH_32 | HEIGHT_24 | 0x80003AC0)
#define ROOM_24_TILESET_SIZE        3104 // bytes

#define INTROMD_TILESET_SIZE        10624 // bytes
#define HISTORY_TILESET_SIZE        7104 // bytes
#define PARCHMENT1_TILESET_SIZE     2400 // bytes
#define PARCHMENT2_TILESET_SIZE     2400 // bytes
#define PARCHMENT3_TILESET_SIZE     2560 // bytes
#define PARCHMENT4_TILESET_SIZE     2784 // bytes
#define PARCHMENT5_TILESET_SIZE     2688 // bytes
#define PARCHMENT6_TILESET_SIZE     2272 // bytes
#define REDPARCH_TILESET_SIZE       4096 // bytes
#define BLUEPARCH_TILESET_SIZE      3616 // bytes
#define GAMEOVER_TILESET_SIZE       1472 // bytes
#define ENDING_TILESET_SIZE         14304 // bytes

#define ENDING_TILE_600_72_ID       0x009F
#define ENDING_TILE_608_72_ID       0x00A0
#define ENDING_TILE_616_72_ID       0x00A1
#define ENDING_TILE_624_72_ID       0x00A2
#define ENDING_TILE_632_72_ID       0x00A3
#define ENDING_TILE_640_72_ID       0x00A4
#define ENDING_TILE_648_72_ID       0x00A5
#define ENDING_TILE_656_72_ID       0x00A6
#define ENDING_TILE_600_80_ID       0x00A7
#define ENDING_TILE_608_80_ID       0x00A8
#define ENDING_TILE_616_80_ID       0x00A9
#define ENDING_TILE_624_80_ID       0x00AA
#define ENDING_TILE_632_80_ID       0x00AB
#define ENDING_TILE_640_80_ID       0x00AC
#define ENDING_TILE_648_80_ID       0x00AD
#define ENDING_TILE_656_80_ID       0x00AE
#define ENDING_TILE_600_88_ID       0x00AF
#define ENDING_TILE_608_88_ID       0x00B0
#define ENDING_TILE_616_88_ID       0x00B1
#define ENDING_TILE_624_88_ID       0x00B2
#define ENDING_TILE_632_88_ID       0x00B3
#define ENDING_TILE_640_88_ID       0x00B4
#define ENDING_TILE_648_88_ID       0x00B5
#define ENDING_TILE_656_88_ID       0x00B6
#define ENDING_TILE_600_96_ID       0x00B7
#define ENDING_TILE_608_96_ID       0x00B8
#define ENDING_TILE_616_96_ID       0x00B9
#define ENDING_TILE_624_96_ID       0x00BA
#define ENDING_TILE_632_96_ID       0x00BB
#define ENDING_TILE_640_96_ID       0x00BC
#define ENDING_TILE_648_96_ID       0x00BD
#define ENDING_TILE_656_96_ID       0x00BE
#define ENDING_TILE_600_104_ID      0x00BF
#define ENDING_TILE_608_104_ID      0x00C0
#define ENDING_TILE_616_104_ID      0x00C1
#define ENDING_TILE_624_104_ID      0x00C2
#define ENDING_TILE_632_104_ID      0x00C3
#define ENDING_TILE_640_104_ID      0x00C4
#define ENDING_TILE_648_104_ID      0x00C5
#define ENDING_TILE_656_104_ID      0x00C6
#define ENDING_TILE_600_112_ID      0x00C7
#define ENDING_TILE_608_112_ID      0x00C8
#define ENDING_TILE_616_112_ID      0x00C9
#define ENDING_TILE_624_112_ID      0x00CA
#define ENDING_TILE_632_112_ID      0x00CB
#define ENDING_TILE_640_112_ID      0x00CC
#define ENDING_TILE_648_112_ID      0x00CD
#define ENDING_TILE_656_112_ID      0x00CE
#define ENDING_TILE_664_72_ID       0x00CF
#define ENDING_TILE_672_72_ID       0x00D0
#define ENDING_TILE_680_72_ID       0x00D1
#define ENDING_TILE_688_72_ID       0x00D2
#define ENDING_TILE_696_72_ID       0x00D3
#define ENDING_TILE_704_72_ID       0x00D4
#define ENDING_TILE_712_72_ID       0x00D5
#define ENDING_TILE_720_72_ID       0x00D6
#define ENDING_TILE_664_80_ID       0x00D7
#define ENDING_TILE_672_80_ID       0x00D8
#define ENDING_TILE_680_80_ID       0x00D9
#define ENDING_TILE_688_80_ID       0x00DA
#define ENDING_TILE_696_80_ID       0x00DB
#define ENDING_TILE_704_80_ID       0x00DC
#define ENDING_TILE_712_80_ID       0x00DD
#define ENDING_TILE_720_80_ID       0x00DE
#define ENDING_TILE_664_88_ID       0x00DF
#define ENDING_TILE_672_88_ID       0x00E0
#define ENDING_TILE_680_88_ID       0x00E1
#define ENDING_TILE_688_88_ID       0x00E2
#define ENDING_TILE_696_88_ID       0x00E3
#define ENDING_TILE_704_88_ID       0x00E4
#define ENDING_TILE_712_88_ID       0x00E5
#define ENDING_TILE_720_88_ID       0x00E6
#define ENDING_TILE_664_96_ID       0x00E7
#define ENDING_TILE_672_96_ID       0x00E8
#define ENDING_TILE_680_96_ID       0x00E9
#define ENDING_TILE_688_96_ID       0x00EA
#define ENDING_TILE_696_96_ID       0x00EB
#define ENDING_TILE_704_96_ID       0x00EC
#define ENDING_TILE_712_96_ID       0x00ED
#define ENDING_TILE_720_96_ID       0x00EE
#define ENDING_TILE_664_104_ID      0x00EF
#define ENDING_TILE_672_104_ID      0x00F0
#define ENDING_TILE_680_104_ID      0x00F1
#define ENDING_TILE_688_104_ID      0x00F2
#define ENDING_TILE_696_104_ID      0x00F3
#define ENDING_TILE_704_104_ID      0x00F4
#define ENDING_TILE_712_104_ID      0x00F5
#define ENDING_TILE_720_104_ID      0x00F6
#define ENDING_TILE_664_112_ID      0x00F7
#define ENDING_TILE_672_112_ID      0x00F8
#define ENDING_TILE_680_112_ID      0x00F9
#define ENDING_TILE_688_112_ID      0x00FA
#define ENDING_TILE_696_112_ID      0x00FB
#define ENDING_TILE_704_112_ID      0x00FC
#define ENDING_TILE_712_112_ID      0x00FD
#define ENDING_TILE_720_112_ID      0x00FE
#define ENDING_TILE_728_72_ID       0x00FF
#define ENDING_TILE_736_72_ID       0x0100
#define ENDING_TILE_744_72_ID       0x0101
#define ENDING_TILE_752_72_ID       0x0102
#define ENDING_TILE_760_72_ID       0x0103
#define ENDING_TILE_768_72_ID       0x0104
#define ENDING_TILE_776_72_ID       0x0105
#define ENDING_TILE_784_72_ID       0x0106
#define ENDING_TILE_728_80_ID       0x0107
#define ENDING_TILE_736_80_ID       0x0108
#define ENDING_TILE_744_80_ID       0x0109
#define ENDING_TILE_752_80_ID       0x010A
#define ENDING_TILE_760_80_ID       0x010B
#define ENDING_TILE_768_80_ID       0x010C
#define ENDING_TILE_776_80_ID       0x010D
#define ENDING_TILE_784_80_ID       0x010E
#define ENDING_TILE_728_88_ID       0x010F
#define ENDING_TILE_736_88_ID       0x0110
#define ENDING_TILE_744_88_ID       0x0111
#define ENDING_TILE_752_88_ID       0x0112
#define ENDING_TILE_760_88_ID       0x0113
#define ENDING_TILE_768_88_ID       0x0114
#define ENDING_TILE_776_88_ID       0x0115
#define ENDING_TILE_784_88_ID       0x0116
#define ENDING_TILE_728_96_ID       0x0117
#define ENDING_TILE_736_96_ID       0x0118
#define ENDING_TILE_744_96_ID       0x0119
#define ENDING_TILE_752_96_ID       0x011A
#define ENDING_TILE_760_96_ID       0x011B
#define ENDING_TILE_768_96_ID       0x011C
#define ENDING_TILE_776_96_ID       0x011D
#define ENDING_TILE_784_96_ID       0x011E
#define ENDING_TILE_728_104_ID      0x011F
#define ENDING_TILE_736_104_ID      0x0120
#define ENDING_TILE_744_104_ID      0x0121
#define ENDING_TILE_752_104_ID      0x0122
#define ENDING_TILE_760_104_ID      0x0123
#define ENDING_TILE_768_104_ID      0x0124
#define ENDING_TILE_776_104_ID      0x0125
#define ENDING_TILE_784_104_ID      0x0126
#define ENDING_TILE_728_112_ID      0x0127
#define ENDING_TILE_736_112_ID      0x0128
#define ENDING_TILE_744_112_ID      0x0129
#define ENDING_TILE_752_112_ID      0x012A
#define ENDING_TILE_760_112_ID      0x012B
#define ENDING_TILE_768_112_ID      0x012C
#define ENDING_TILE_776_112_ID      0x012D
#define ENDING_TILE_784_112_ID      0x012E
#define ENDING_TILE_792_72_ID       0x012F
#define ENDING_TILE_800_72_ID       0x0130
#define ENDING_TILE_808_72_ID       0x0131
#define ENDING_TILE_816_72_ID       0x0132
#define ENDING_TILE_824_72_ID       0x0133
#define ENDING_TILE_832_72_ID       0x0134
#define ENDING_TILE_840_72_ID       0x0135
#define ENDING_TILE_848_72_ID       0x0136
#define ENDING_TILE_792_80_ID       0x0137
#define ENDING_TILE_800_80_ID       0x0138
#define ENDING_TILE_808_80_ID       0x0139
#define ENDING_TILE_816_80_ID       0x013A
#define ENDING_TILE_824_80_ID       0x013B
#define ENDING_TILE_832_80_ID       0x013C
#define ENDING_TILE_840_80_ID       0x013D
#define ENDING_TILE_848_80_ID       0x013E
#define ENDING_TILE_792_88_ID       0x013F
#define ENDING_TILE_800_88_ID       0x0140
#define ENDING_TILE_808_88_ID       0x0141
#define ENDING_TILE_816_88_ID       0x0142
#define ENDING_TILE_824_88_ID       0x0143
#define ENDING_TILE_832_88_ID       0x0144
#define ENDING_TILE_840_88_ID       0x0145
#define ENDING_TILE_848_88_ID       0x0146
#define ENDING_TILE_792_96_ID       0x0147
#define ENDING_TILE_800_96_ID       0x0148
#define ENDING_TILE_808_96_ID       0x0149
#define ENDING_TILE_816_96_ID       0x014A
#define ENDING_TILE_824_96_ID       0x014B
#define ENDING_TILE_832_96_ID       0x014C
#define ENDING_TILE_840_96_ID       0x014D
#define ENDING_TILE_848_96_ID       0x014E
#define ENDING_TILE_792_104_ID      0x014F
#define ENDING_TILE_800_104_ID      0x0150
#define ENDING_TILE_808_104_ID      0x0151
#define ENDING_TILE_816_104_ID      0x0152
#define ENDING_TILE_824_104_ID      0x0153
#define ENDING_TILE_832_104_ID      0x0154
#define ENDING_TILE_840_104_ID      0x0155
#define ENDING_TILE_848_104_ID      0x0156
#define ENDING_TILE_792_112_ID      0x0157
#define ENDING_TILE_800_112_ID      0x0158
#define ENDING_TILE_808_112_ID      0x0159
#define ENDING_TILE_816_112_ID      0x015A
#define ENDING_TILE_824_112_ID      0x015B
#define ENDING_TILE_832_112_ID      0x015C
#define ENDING_TILE_840_112_ID      0x015D
#define ENDING_TILE_848_112_ID      0x015E
#define ENDING_TILE_856_72_ID       0x015F
#define ENDING_TILE_864_72_ID       0x0160
#define ENDING_TILE_872_72_ID       0x0161
#define ENDING_TILE_880_72_ID       0x0162
#define ENDING_TILE_888_72_ID       0x0163
#define ENDING_TILE_896_72_ID       0x0164
#define ENDING_TILE_904_72_ID       0x0165
#define ENDING_TILE_912_72_ID       0x0166
#define ENDING_TILE_856_80_ID       0x0167
#define ENDING_TILE_864_80_ID       0x0168
#define ENDING_TILE_872_80_ID       0x0169
#define ENDING_TILE_880_80_ID       0x016A
#define ENDING_TILE_888_80_ID       0x016B
#define ENDING_TILE_896_80_ID       0x016C
#define ENDING_TILE_904_80_ID       0x016D
#define ENDING_TILE_912_80_ID       0x016E
#define ENDING_TILE_856_88_ID       0x016F
#define ENDING_TILE_864_88_ID       0x0170
#define ENDING_TILE_872_88_ID       0x0171
#define ENDING_TILE_880_88_ID       0x0172
#define ENDING_TILE_888_88_ID       0x0173
#define ENDING_TILE_896_88_ID       0x0174
#define ENDING_TILE_904_88_ID       0x0175
#define ENDING_TILE_912_88_ID       0x0176
#define ENDING_TILE_856_96_ID       0x0177
#define ENDING_TILE_864_96_ID       0x0178
#define ENDING_TILE_872_96_ID       0x0179
#define ENDING_TILE_880_96_ID       0x017A
#define ENDING_TILE_888_96_ID       0x017B
#define ENDING_TILE_896_96_ID       0x017C
#define ENDING_TILE_904_96_ID       0x017D
#define ENDING_TILE_912_96_ID       0x017E
#define ENDING_TILE_856_104_ID      0x017F
#define ENDING_TILE_864_104_ID      0x0180
#define ENDING_TILE_872_104_ID      0x0181
#define ENDING_TILE_880_104_ID      0x0182
#define ENDING_TILE_888_104_ID      0x0183
#define ENDING_TILE_896_104_ID      0x0184
#define ENDING_TILE_904_104_ID      0x0185
#define ENDING_TILE_912_104_ID      0x0186
#define ENDING_TILE_856_112_ID      0x0187
#define ENDING_TILE_864_112_ID      0x0188
#define ENDING_TILE_872_112_ID      0x0189
#define ENDING_TILE_880_112_ID      0x018A
#define ENDING_TILE_888_112_ID      0x018B
#define ENDING_TILE_896_112_ID      0x018C
#define ENDING_TILE_904_112_ID      0x018D
#define ENDING_TILE_912_112_ID      0x018E
#define ENDING_TILE_920_72_ID       0x018F
#define ENDING_TILE_928_72_ID       0x0190
#define ENDING_TILE_936_72_ID       0x0191
#define ENDING_TILE_944_72_ID       0x0192
#define ENDING_TILE_952_72_ID       0x0193
#define ENDING_TILE_960_72_ID       0x0194
#define ENDING_TILE_968_72_ID       0x0195
#define ENDING_TILE_976_72_ID       0x0196
#define ENDING_TILE_920_80_ID       0x0197
#define ENDING_TILE_928_80_ID       0x0198
#define ENDING_TILE_936_80_ID       0x0199
#define ENDING_TILE_944_80_ID       0x019A
#define ENDING_TILE_952_80_ID       0x019B
#define ENDING_TILE_960_80_ID       0x019C
#define ENDING_TILE_968_80_ID       0x019D
#define ENDING_TILE_976_80_ID       0x019E
#define ENDING_TILE_920_88_ID       0x019F
#define ENDING_TILE_928_88_ID       0x01A0
#define ENDING_TILE_936_88_ID       0x01A1
#define ENDING_TILE_944_88_ID       0x01A2
#define ENDING_TILE_952_88_ID       0x01A3
#define ENDING_TILE_960_88_ID       0x01A4
#define ENDING_TILE_968_88_ID       0x01A5
#define ENDING_TILE_976_88_ID       0x01A6
#define ENDING_TILE_920_96_ID       0x01A7
#define ENDING_TILE_928_96_ID       0x01A8
#define ENDING_TILE_936_96_ID       0x01A9
#define ENDING_TILE_944_96_ID       0x01AA
#define ENDING_TILE_952_96_ID       0x01AB
#define ENDING_TILE_960_96_ID       0x01AC
#define ENDING_TILE_968_96_ID       0x01AD
#define ENDING_TILE_976_96_ID       0x01AE
#define ENDING_TILE_920_104_ID      0x01AF
#define ENDING_TILE_928_104_ID      0x01B0
#define ENDING_TILE_936_104_ID      0x01B1
#define ENDING_TILE_944_104_ID      0x01B2
#define ENDING_TILE_952_104_ID      0x01B3
#define ENDING_TILE_960_104_ID      0x01B4
#define ENDING_TILE_968_104_ID      0x01B5
#define ENDING_TILE_976_104_ID      0x01B6
#define ENDING_TILE_920_112_ID      0x01B7
#define ENDING_TILE_928_112_ID      0x01B8
#define ENDING_TILE_936_112_ID      0x01B9
#define ENDING_TILE_944_112_ID      0x01BA
#define ENDING_TILE_952_112_ID      0x01BB
#define ENDING_TILE_960_112_ID      0x01BC
#define ENDING_TILE_968_112_ID      0x01BD
#define ENDING_TILE_976_112_ID      0x01BE

#endif /* GRAPHICS_H_ */
