/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"

void history(int * state) {
    int32_t posjean = -15 << 8;
    int32_t posenem[4] = { -17 << 8, -17 << 8, -17 << 8, -17 << 8 };
    int32_t animation = 0;
    int32_t i = 0;
    int32_t idx = 0;

    mailbox[0] = GPU_HISTORY_TILES_RAM;
    mailbox[1] = HISTORY_TILESET_SIZE;
    mailbox[2] = GPU_HISTORY_TILEMAP;
    hs_tx(sizeof(mailbox) / 4, (int32_t) mailbox, 3, GPU_MAILBOX);

    while (1) {
        // vsync
        waitpeq(GPU_VSYNC, GPU_VSYNC);
        waitpne(GPU_VSYNC, GPU_VSYNC);

        /* Animation control */
        if (animation < 13)
            animation++;
        else
            animation = 0;

        idx = 0;

        /* Jean running */
        if (posjean < (255 << 8)) {
            posjean += INC_0_75;
            sprite_ram[idx++] = (88 << 9) | ((posjean & 0x1FF00) >> 8) | MIRROR_FLAG;
            sprite_ram[idx++] = GPU_TILES_RAM + SPRITE_320_88_OFS + ((animation / 7) * 192);
        }
        else {
            sprite_ram[idx++] = 0;
            sprite_ram[idx++] = 0;
        }

        /* Crusaders running */
        /* When start running */
        for (i = 0; i < 4; i++) {
            if (posjean > ((35 + (30 * i)) << 8))
                posenem[i] += INC_0_65;
        }
        /* Draw */
        for (i = 0; i < 4; i++) {
            if ((posenem[i] > (-15 << 8)) && (posenem[i] < (255 << 8))) {
                sprite_ram[idx++] = (88 << 9) | ((posenem[i] & 0x1FF00) >> 8) | MIRROR_FLAG;
                sprite_ram[idx++] = GPU_TILES_RAM + SPRITE_64_64_OFS + (192 * (animation / 7));
            }
            else {
                sprite_ram[idx++] = 0;
                sprite_ram[idx++] = 0;
            }
        }

        hs_tx(sizeof(sprite_ram) / 4, (int32_t) sprite_ram, 1, GPU_SPRITE_RAM);

        if (posenem[3] > (256 << 8)) { /* Ending history */
            *state = 2;
            return;
        }
    }

    *state = 0;
}
