#
# Abbaye des Morts for Parallax Propeller
# High speed Prop-to-Prop serial communication
#
# Author: Beau Schwabe
# MIT Licensed
#

                    .pasm
                    .compress off

                    .section .cog_hsp2prx_driver, "ax"

                    .org     0

# Start RX proceedure ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
RX_Propeller
# Clear Status Flag ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
                    rdlong  DataSamples, par        ' read data samples
                    andn    DataSamples, #$F        ' clear flag; data packet busy
                    wrlong  DataSamples, par        ' update flag status
# Get Address for Input Packet Header (Contents written here are from TX)
                    mov     _PacketHeaderIn, par    ' Read Data Address Location
                    add     _PacketHeaderIn, #4
# Parse Output Packet Header so we know where to write the incomming data
                    rdlong  Buff, par               ' Read PacketHeader contents
                    mov     DataIndex, Buff
                    and     DataIndex, AddressMask  ' DataIndex points to data buffer
                    shr     DataIndex, #4
# Create Pin Mask for data transmission line
                    mov     PinMask, #1             ' Create Pin Mask for Input/Output pin
                    shl     PinMask, Pin
                    or      outa, PinMask           ' Preset Pin HIGH
                    andn    dira, PinMask           ' Make Pin an INPUT Hi-Z LOW
# Setup Counter to count during data-pin HIGH times
                    movi    ctra, #%0_11010_000     ' LOGIC A
                    movs    ctra, Pin
                    mov     frqa, #1
# Detect 3.3us Packet SYNC
Packet_SYNC
                    waitpne PinMask, PinMask        ' Wait for LOW
                    mov     phsa, #0 wz             ' clear phsa and set Z flag
                                                    ' Note: Z flag is used to
                                                    '      Determine DataSamples
                                                    '      further down in code
                    waitpeq PinMask, PinMask        ' Wait for HIGH
                    waitpne PinMask, PinMask        ' Wait for LOW
                    mov     temp, phsa              ' read phsa
                    cmp     temp, #262  wc          ' <- 264 clocks at 80MHz equals 3.3us
            if_c    jmp     #Packet_SYNC            ' Jump if pulse is less than 3.3us
# 3.3us pulse detected...
                    or      dira, PinMask           ' Make pin HIGH
                    andn    dira, PinMask           ' Make Pin an INPUT Hi-Z LOW

_RX
                    waitpeq PinMask, PinMask        ' Wait for HIGH
                    waitpne PinMask, PinMask        ' Wait for LOW
# Read 1 LONG after sync ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0
                    test    PinMask, ina wc         ' Read RX pin into "C"
                    rcl     Buff,#1                 ' Rotate Buff left and place "C" in Bit0

# Detect Packet Size with first received long ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
            if_z    mov     DataSamples, Buff       ' Set first reading to number of DataSamples
            if_z    shr     DataSamples, #18        ' Clear "Z" flag in the dnjz below, so this
                                                    ' only gets executed once.
            if_z    add     DataSamples, #1
# Write Data and get next long ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
            if_z    wrlong  Buff, _PacketHeaderIn   ' Write received value to Start Address +4

            if_z    and     Buff, AddressMask       ' Parse data and add Dest Offset to Index
            if_z    shr     Buff, #2
            if_z    add     DataIndex, Buff

            if_nz   wrlong  Buff, DataIndex         ' Write received value to Indexed Address

            if_nz   add     DataIndex, #4           ' Increment Index value
                    djnz    DataSamples, #_RX  wz   ' Check to see if there are more data samples
# Set Status Flag ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
                    rdlong  DataSamples, par        ' read data samples
                    or      DataSamples, #$F        ' set flag; data packet done
                    wrlong  DataSamples, par        ' update flag status
# Terminate RX proceedure ≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈≈
                    cogid   temp                    ' Get this COG ID
                    cogstop temp                    ' STOP this COG

#ifdef LCD_BOARD
Pin                 long    23
#else
Pin                 long    25
#endif
PinMask             long    0
Buff                long    0
DataSamples         long    0
DataIndex           long    0
temp                long    0

AddressMask         long    $7FFF0
_PacketHeaderIn     long    0
delay               long    0
DestOffset          long    0
