/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#ifndef I2C_DRIVER_H_
#define I2C_DRIVER_H_

#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif

#define I2C_SCL         28
#define I2C_SDA         29

#define I2C_ACK         0
#define I2C_NAK         1
#define I2C_WRITE       0
#define I2C_READ        1

void i2c_initialize();
void i2c_start();
void i2c_stop();
int32_t i2c_write(uint8_t data);
uint8_t i2c_read(int32_t ack);

int32_t i2c_read_page(uint32_t addr, uint8_t * ptr, uint32_t count);

#ifdef __cplusplus
}
#endif

#endif /* I2C_DRIVER_H_ */
