/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_05_06_drawenemies()
{
    int i;

    for (i = 0; i < 4; i++) {
        /* Init values */
        if (enemies[i].type != 16) {
            enemies[i].type = 16;
            enemies[i].x = (-52 - (24 * i)) << 8;
            enemies[i].y = 136 << 8;
        }

        /* Mover & animation */
        /* Jump when needed */
        if (room[0] == 5) {
            if ((enemies[i].x == (146 << 8)) || (enemies[i].x == (160 << 8)))
                enemies[i].fire = 1; /* Using fire as jump flag */
        }
        else if (room[0] == 6) {
            if ((enemies[i].x == (76 << 8)) || (enemies[i].x == ((124 << 8) | 192)) || (enemies[i].x == (155 << 8)))
                enemies[i].fire = 2;
            if ((enemies[i].x == ((208 << 8) | 64)) || (enemies[i].x == ((220 << 8) | 128)))
                enemies[i].fire = 1; /* Using fire as jump flag */
        }

        /* Jump */
        if (enemies[i].fire == 1) { /* Short jump */
            if (enemies[i].speed < 23) {
                enemies[i].speed += 2;
                enemies[i].y -= INC_1_0;
                enemies[i].animation = 0;
            }
            else {
                enemies[i].y += INC_1_0;
                enemies[i].speed += 2;
                enemies[i].animation = 0;
            }
            if (enemies[i].speed == 32) { /* Touching ground, reboot flags */
                enemies[i].speed = 0;
                enemies[i].fire = 0;
            }
        }
        else if (enemies[i].fire == 2) { /* Long jump */
            if (enemies[i].speed < 8) {
                enemies[i].speed += 1;
                enemies[i].y -= INC_1_0;
                enemies[i].animation = 0;
            }
            else {
                enemies[i].y += INC_1_0;
                enemies[i].speed += 1;
                enemies[i].animation = 0;
            }
            if (enemies[i].speed == 16) {
                enemies[i].fire = 0;
                enemies[i].speed = 0;
            }
        }

        if (enemies[i].animation < 13)
            enemies[i].animation++;
        else
            enemies[i].animation = 0;

        /* Fall */
        if (room[0] == 5) {
            if (enemies[i].x > (206 << 8)) {
                if (enemies[i].speed < 8) {
                    enemies[i].speed++;
                    enemies[i].y += INC_2_0;
                    enemies[i].animation = 0;
                }
            }
        }

        /* Movement */
        if ((room[0] == 6) && (enemies[i].speed > 0))
            enemies[i].x += INC_0_75;
        else
            enemies[i].x += INC_0_5;

        if ((enemies[i].x > -INC_8_0) && (enemies[i].x < (256 << 8))) {
            sprite_ram[sprite_idx++] = ((enemies[i].y & 0x1FF00) << 1) | ((enemies[i].x & 0x1FF00) >> 8) | MIRROR_FLAG;
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + SPRITE_64_64_OFS + (192 * (enemies[i].animation / 7));
        }
    }
}

void room_06_touchobj()
{
    int x = 0;
    int y = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    /* Touch spikes, water or fire */
    if (((video_ram[y+3][x] == TILE005_ID) || (video_ram[y+3][x+1] == TILE005_ID)) || (((video_ram[y+3][x] >= TILE501_ID) && (video_ram[y+3][x] <= TILE504_ID))|| ((video_ram[y+3][x+1] >= TILE501_ID) && (video_ram[y+3][x+1] <= TILE504_ID))) || (((video_ram[y+3][x] == TILE059_ID) || (video_ram[y+3][x] == TILE059_ID)) || ((video_ram[y+3][x+1] == TILE060_ID) && (video_ram[y+3][x+1] == TILE060_ID)))) {
        if ((room[0] == 11) && (y+3 == 20) && (x < 4))
            jean.death = 0;
        else {
            if (jean.death == 0)
                jean.death = 1;
        }
    }
}
