/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

static void showparchment() {
    memset(sprite_ram, 0, sizeof(sprite_ram));

    hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 0, GPU_SPRITE_RAM);
    hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 3, GPU_MAILBOX);
    waitcnt(CNT + _CLKFREQ * 5);

    hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 5, GPU_SPRITE_RAM);
    hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
}

void room_08_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    if (y > 0) {

        TOUCH_CHECKPOINT

        /* Touch yellow parchment */
        if (((video_ram[y+1][x] >= TILE317_ID) && (video_ram[y+1][x] <= TILE320_ID)) || ((video_ram[y+1][x+1] >= TILE317_ID) && (video_ram[y+1][x+1] <= TILE320_ID))) {
            for (v=0;v<22;v++) {
                for (h=0;h<32;h++) {
                    if ((video_ram[v][h] >= TILE317_ID) && (video_ram[v][h] <= TILE320_ID))
                        video_ram[v][h] = 0;
                }
            }

            mailbox[0] = GPU_PARCHMENT2_TILES_RAM;
            mailbox[1] = PARCHMENT2_TILESET_SIZE;
            mailbox[2] = GPU_PARCHMENT2_TILEMAP;
            showparchment();
            spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        }
    }
}

void room_08_events()
{
    /* Open ground */
    if ((jean.x > INC_15_0) && (jean.flags[1] == 1) && (video_ram[20][26] == TILE007_ID)) {
        video_ram[20][26] = TILE038_ID;
        video_ram[20][27] = 0;
        video_ram[21][26] = 0;
        video_ram[21][27] = 0;
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        //Mix_PlayChannel(-1, fx[1], 0);
        waitcnt(CNT + _CLKFREQ);
    }

    /* Open door */
    if ((jean.x > (211 << 8)) && (jean.flags[2] == 1) && (video_ram[14][31] == TILE343_ID)) {
        video_ram[14][31] = 0;
        video_ram[15][31] = 0;
        video_ram[16][31] = 0;
        video_ram[17][31] = 0;
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        //Mix_PlayChannel(-1, fx[1], 0);
        waitcnt(CNT + _CLKFREQ);
    }
}
