/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

static void showparchment() {
    memset(sprite_ram, 0, sizeof(sprite_ram));

    hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 0, GPU_SPRITE_RAM);
    hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 3, GPU_MAILBOX);
    waitcnt(CNT + _CLKFREQ * 5);

    hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 5, GPU_SPRITE_RAM);
    hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
}

void room_16_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    /* Touch spikes, water or fire */
    if (((video_ram[y+3][x] == TILE005_ID) || (video_ram[y+3][x+1] == TILE005_ID)) || (((video_ram[y+3][x] >= TILE501_ID) && (video_ram[y+3][x] <= TILE504_ID))|| ((video_ram[y+3][x+1] >= TILE501_ID) && (video_ram[y+3][x+1] <= TILE504_ID))) || (((video_ram[y+3][x] == TILE059_ID) || (video_ram[y+3][x] == TILE059_ID)) || ((video_ram[y+3][x+1] == TILE060_ID) && (video_ram[y+3][x+1] == TILE060_ID)))) {
        if ((room[0] == 11) && (y+3 == 20) && (x < 4))
            jean.death = 0;
        else {
            if (jean.death == 0)
                jean.death = 1;
        }
    }

    TOUCH_CROSSES
    TOUCH_HEARTS

    /* Touch yellow parchment */
    if (((video_ram[y+1][x] >= TILE317_ID) && (video_ram[y+1][x] <= TILE320_ID)) || ((video_ram[y+1][x+1] >= TILE317_ID) && (video_ram[y+1][x+1] <= TILE320_ID))) {
        for (v=0;v<22;v++) {
            for (h=0;h<32;h++) {
                if ((video_ram[v][h] >= TILE317_ID) && (video_ram[v][h] <= TILE320_ID))
                    video_ram[v][h] = 0;
            }
        }

        mailbox[0] = GPU_PARCHMENT5_TILES_RAM;
        mailbox[1] = PARCHMENT5_TILESET_SIZE;
        mailbox[2] = GPU_PARCHMENT5_TILEMAP;
        showparchment();
        spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
    }
}
