/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_17_drawenemies()
{
    int i, n;
    uint32_t sprite0 = 0;
    uint32_t sprite1 = GPU_TILES_RAM + ROOM_17_SPRITE_624_24_OFS;

    common_drawenemies();

    DRAW_SHOTS
}

void room_17_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;
    int r = 0;
    int flag = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    TOUCH_CROSSES
    TOUCH_HEARTS

    /* Touch switch */
    if ((((video_ram[y + 1][x] >= TILE331_ID) && (video_ram[y + 1][x] <= TILE338_ID)) || ((video_ram[y + 1][x + 1] >= TILE331_ID) && (video_ram[y + 1][x + 1] <= TILE338_ID))) && (jean.flags[5] == 0)) {
        for (v = 2; v < 4; v++) {
            for (h = 15; h < 17; h++) {
                if ((video_ram[v][h] >= TILE331_ID) && (video_ram[v][h] <= TILE334_ID)) {
                    video_ram[v][h] += 4;
                    jean.flags[5] = 1;
                }
                else if (((video_ram[v][h] >= TILE335_ID) && (video_ram[v][h] <= TILE338_ID)) && (jean.flags[5] == 0))
                    video_ram[v][h] -= 4;
            }
        }
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        jean.flags[5] = 1;

        /* Flapping all crosses  */
        for (r = 1; r < 25; r++) {
            spi_read((r - 1) * (MAP_SIZE), (uint8_t *)video_ram, MAP_SIZE);
            for (v = 0; v < 22; v++) {
                for (h = 0; h < 32; h++) {
                    flag = 0;
                    /* Crosses enabled */
                    if ((video_ram[v][h] >= TILE409_ID) && (video_ram[v][h] <= TILE412_ID)) {
                        video_ram[v][h] += 8;
                        flag = 1;
                    }
                    /* Crosses disabled */
                    else if ((video_ram[v][h] >= TILE425_ID) && (video_ram[v][h] <= TILE428_ID) && (flag == 0))
                        video_ram[v][h] -= 8;
                }
            }
            spi_write((r - 1) * (MAP_SIZE), (uint8_t *)video_ram, MAP_SIZE);
        }

        spi_read((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);

        //Mix_PauseMusic();
        //Mix_PlayChannel(-1, fx[5], 0);
        waitcnt(CNT + _CLKFREQ * 2);
        //Mix_ResumeMusic();
    }
}
