/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_18_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    /* Touch spikes, water or fire */
    if (((video_ram[y+3][x] == TILE005_ID) || (video_ram[y+3][x+1] == TILE005_ID)) || (((video_ram[y+3][x] >= TILE501_ID) && (video_ram[y+3][x] <= TILE504_ID))|| ((video_ram[y+3][x+1] >= TILE501_ID) && (video_ram[y+3][x+1] <= TILE504_ID))) || (((video_ram[y+3][x] == TILE059_ID) || (video_ram[y+3][x] == TILE059_ID)) || ((video_ram[y+3][x+1] == TILE060_ID) && (video_ram[y+3][x+1] == TILE060_ID)))) {
        if ((room[0] == 11) && (y+3 == 20) && (x < 4))
            jean.death = 0;
        else {
            if (jean.death == 0)
                jean.death = 1;
        }
    }

    TOUCH_CROSSES
    TOUCH_HEARTS
}

void death() {

    int x = 0;
    int y = 0;
    int n = 0;

    if (enemies[0].speed < 60)
        enemies[0].speed++;
    else
        enemies[0].speed = 0;

    /* Movimiento */
    if (enemies[0].direction == 0) { /* Left mov. */
        if (enemies[0].x > enemies[0].limleft)
            enemies[0].x -= INC_1_0;
        else
            enemies[0].direction = 1;
    }
    if (enemies[0].direction == 1) { /* Right mov. */
        if (enemies[0].x < enemies[0].limright)
            enemies[0].x += INC_1_0;
        else
            enemies[0].direction = 0;
    }

    /* Init axes */
    if ((enemies[0].speed == 45) && (enemies[0].x > (48 << 8))) {
        for (x = 0; x < 8; x += 2) {
            if (proyec[x] == 0) {
                proyec[x] = enemies[0].y + (35 << 8);
                proyec[x + 1] = enemies[0].x;
                x = 9;
                //Mix_PlayChannel(-1, fx[0], 0);
            }
        }
    }

    /* Animation */
    if (enemies[0].speed < 45) {
        if ((counter[0] == 1) || (counter[0] == 11) || (counter[0] == 21)) {
            if (enemies[0].animation == 0)
                enemies[0].animation = 1;
            else
                enemies[0].animation = 0;
        }
    } else {
        if (enemies[0].x > (48 << 8)) {
            if (enemies[0].speed < 55)
                enemies[0].animation = 2;
            else
                enemies[0].animation = 0;
        }
    }

    /* Draw */
    sprite_ram[sprite_idx] = ((enemies[0].y & 0x1FF00) << 1) | ((enemies[0].x & 0x1FF00) >> 8);
    if (enemies[0].direction == 1)
        sprite_ram[sprite_idx] |= MIRROR_FLAG;
    sprite_idx++;
    sprite_ram[sprite_idx++] = GPU_TILES_RAM + enemies[0].tile + enemies[0].animation * 512;

    /* Axes movement */
    for (n = 0; n < 8; n += 2) {

        if (proyec[n] > 0) {
            /* Locating axe */
            x = proyec[n + 1] / 0x800;
            y = proyec[n] / 0x800;

            /* Touching ground, take out & cleaning */
            if (y == 20) {
                proyec[n] = 0;
                proyec[n + 1] = 0;
            }
            else {
                /* Touching a solid tile ? Move */
                if (((video_ram[y + 2][x] != TILE073_ID) && (video_ram[y + 2][x] != TILE075_ID)) && ((video_ram[y + 2][x + 1] != TILE073_ID) && (video_ram[y + 2][x + 1] != TILE075_ID)))
                    proyec[n] += INC_1_0;
                else
                    proyec[n + 1] -= INC_1_0;
            }
            if (x == 0) {
                proyec[n] = 0;
                proyec[n + 1] = 0;
            }
        }
    }

    /* Draw axe */
    for (n = 0; n < 8; n += 2) {
        if (proyec[n] > 0) {
            sprite_ram[sprite_idx++] = ((proyec[n] & 0x1FF00) << 1) | ((proyec[n + 1] & 0x1FF00) >> 8);
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_18_SPRITE_576_56_OFS + (128 * (counter[2] / 2));
        }
    }
}
