/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_20_drawenemies()
{
    int i, n;
    uint32_t sprite0 = 0;
    uint32_t sprite1 = GPU_TILES_RAM + ROOM_20_SPRITE_656_24_OFS;

    common_drawenemies();

    DRAW_SHOTS
}

void room_20_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    TOUCH_CROSSES
    TOUCH_HEARTS
    TOUCH_LEVER
}

void room_20_events()
{
    /* Open door */
    if ((jean.x > (208 << 8)) && (jean.flags[4] == 1) && (video_ram[14][31] == TILE343_ID)) {
        video_ram[14][31] = 0;
        video_ram[15][31] = 0;
        video_ram[16][31] = 0;
        video_ram[17][31] = 0;
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        //Mix_PlayChannel(-1, fx[1], 0);
        waitcnt(CNT + _CLKFREQ);
    }
}
